proc Activate_of_Valid_Value  { val crit } {
	if { $val >= $crit } {
		return 1
	} else {
		return -1
	}
}

proc TK_Activate_R_C { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

	set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]
	if { $Advanced_check == 1 } {

	      set oR_C [DWLocalGetValue $GDN $STRUCT $QUESTION]
	        set n [GidConvertValueUnit $oR_C]
	      set n [ParserNumberUnit $n oR_C unit]

	      set oS_T [DWLocalGetValue $GDN $STRUCT "S_T"]
	        set n [GidConvertValueUnit $oS_T]
	      set n [ParserNumberUnit $n oS_T unit]

	      set odR  [expr $oR_C-$oS_T]

	      #              kontrolni funkce   prom  min  message
	      set ret_val [Activate_of_Valid_Value $odR  0.049 ]
	      if { $ret_val == -1 } {
		       WarnWinText "R_C have to be > S_T more then 0.05m, dR=$odR"
	      }
	} else {
	      return ""
	}
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
}

proc TK_Activate_R_G_Modif_R_A { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

	set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]
	if { $Advanced_check == 1 } {
	      set oR_G [DWLocalGetValue $GDN $STRUCT $QUESTION]
	      set oI_Z [DWLocalGetValue $GDN $STRUCT "I_Z"]
	      set oR_E [DWLocalGetValue $GDN $STRUCT "R_E"]
	      set oS_T [DWLocalGetValue $GDN $STRUCT "S_T"]

	        set n [GidConvertValueUnit $oR_G]
	      set n [ParserNumberUnit $n oR_G unit]
	        set n [GidConvertValueUnit $oI_Z]
	      set n [ParserNumberUnit $n oI_Z unit]
	        set n [GidConvertValueUnit $oR_E]
	      set n [ParserNumberUnit $n oR_E unit]
	        set n [GidConvertValueUnit $oS_T]
	      set n [ParserNumberUnit $n oS_T unit]

	      set oR_A [expr $oI_Z - $oR_E - $oR_G]

# check of R_G
	      set odR [expr $oR_G-$oS_T]
	      #              kontrolni funkce   prom  min  message
	      set ret_val [Activate_of_Valid_Value $odR  0.049 ]
	      if { $ret_val == -1 } {
		       WarnWinText "R_G have to be > S_T more then 0.05m, dR=$odR"
	      }

# check of R_A
	      set oR_C [DWLocalGetValue $GDN $STRUCT "R_C"]
	      	set n [GidConvertValueUnit $oR_C]
	      set n [ParserNumberUnit $n oR_C unit]

	      set odR [expr $oR_A-$oR_C]
	      #              kontrolni funkce   prom  min  message
	      set ret_val [Activate_of_Valid_Value $odR  0.049 ]
	      if { $ret_val == 1 } {
		      DWLocalSetValue $GDN $STRUCT "R_A" [format %g%s $oR_A $unit]
	      } else {
		       WarnWinText "R_A($oR_A) have to be > R_C($oR_C) more then 0.05m, dR=$odR"
	      }

	} else {
	      return ""
	}
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
}

proc TK_Modif_B { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

#    set Advanced_check [GiD_AccessValue get gendata  "_Advanced_Frame"]
     set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]
     if { $Advanced_check == 1 } {

#      set oI_Y [GiD_AccessValue get gendata  "I_Y"]
       set oI_Y [DWLocalGetValue $GDN $STRUCT "I_Y"]
         set n [GidConvertValueUnit $oI_Y]
       set n [ParserNumberUnit $n oI_Y unit]

       set oB [expr $oI_Y/2.0]
#      GiD_AccessValue set gendata  "_B" $oB
       DWLocalSetValue $GDN $STRUCT $QUESTION [format %g%s $oB $unit]

     } else {
      return ""
     }
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
  return ""
}

proc TK_Modif_C { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

#    set Advanced_check [GiD_AccessValue get gendata  "_Advanced_Frame"]
     set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]
     if { $Advanced_check == 1 } {

#     set oI_Y [GiD_AccessValue get gendata "I_Y"]
      set oI_Y [DWLocalGetValue $GDN $STRUCT "I_Y"]
        set n [GidConvertValueUnit $oI_Y]
      set n [ParserNumberUnit $n oI_Y unit]

      set oC [expr $oI_Y]
#     GiD_AccessValue set gendata  "_C" $oC
      DWLocalSetValue $GDN $STRUCT $QUESTION [format %g%s $oC $unit]

     } else {
      return ""
     }
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
  return ""
}

proc TK_Modif_E { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

#    set Advanced_check [GiD_AccessValue get gendata  "_Advanced_Frame"]
     set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]

     if { $Advanced_check == 1 } {

#     set oI_Z [GiD_AccessValue get gendata  "I_Z"]
      set oI_Z [DWLocalGetValue $GDN $STRUCT "I_Z"]
        set n [GidConvertValueUnit $oI_Z]
      set n [ParserNumberUnit $n oI_Z unit]

#     set oR_E [GiD_AccessValue get gendata  "R_E"]
      set oR_E [DWLocalGetValue $GDN $STRUCT "R_E"]
         set n [GidConvertValueUnit $oR_E]
      set n [ParserNumberUnit $n oR_E unit]

      set oE [expr $oI_Z*2.0+$oR_E]
#     GiD_AccessValue set gendata  "_E" $oE
      DWLocalSetValue $GDN $STRUCT $QUESTION [format %g%s $oE $unit]

     } else {
      return ""
     }
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
  return ""
}

proc TK_Modif_F { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	set GDN [lindex $args 0]
	set STRUCT [lindex $args 1]
	set QUESTION [lindex $args 2]

#    set Advanced_check [GiD_AccessValue get gendata  "_Advanced_Frame"]
     set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]

     if { $Advanced_check == 1 } {

#     set oI_Z [GiD_AccessValue get gendata  "I_Z"]
      set oI_Z [DWLocalGetValue $GDN $STRUCT "I_Z"]
         set n [GidConvertValueUnit $oI_Z]
      set n [ParserNumberUnit $n oI_Z unit]

#     set oI_E [GiD_AccessValue get gendata  "I_E"]
      set oI_E [DWLocalGetValue $GDN $STRUCT "I_E"]
         set n [GidConvertValueUnit $oI_E]
      set n [ParserNumberUnit $n oI_E unit]

#     set oR_E [GiD_AccessValue get gendata  "R_E"]
      set oR_E [DWLocalGetValue $GDN $STRUCT "R_E"]
         set n [GidConvertValueUnit $oR_E]
      set n [ParserNumberUnit $n oR_E unit]

      set oF   [expr $oI_Z+$oI_E-$oR_E]
#     GiD_AccessValue set gendata  "F" $oF
      DWLocalSetValue $GDN $STRUCT $QUESTION [format %g%s $oF $unit]

     } else {
      return ""
     }
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
  return ""
}

proc Dowel_Generating { } {

      set givalue [format %d [GiD_AccessValue get gendata  "Generate_Dowel_Grid"]]
      set afvalue [format %d [GiD_AccessValue get gendata  "Generate_Dowel_AdvancedFrame"]]

      if { $givalue == 1 || $afvalue == 1 } {
	      GiD_Process layer new Dowel escape escape
      }

      if { $givalue == 1 } {
	      set OldCreateAlwaysNewPoint [GiD_Info variables CreateAlwaysNewPoint]
	      GiD_Process escape escape escape escape utilities variables CreateAlwaysNewPoint 1

	      set s_x1 [GiD_AccessValue get gendata  "S_X1"]
                set n [GidConvertValueUnit $s_x1]
              set n [ParserNumberUnit $n s_x1 unit]

	      set s_x2 [GiD_AccessValue get gendata  "S_X2"]
                set n [GidConvertValueUnit $s_x2]
              set n [ParserNumberUnit $n s_x2 unit]

	      set s_py [GiD_AccessValue get gendata  "S_PY"]
                set n [GidConvertValueUnit $s_py]
              set n [ParserNumberUnit $n s_py unit]

	      set s_pz [GiD_AccessValue get gendata  "S_PZ"]
                set n [GidConvertValueUnit $s_pz]
              set n [ParserNumberUnit $n s_pz unit]

	      set s_dy [GiD_AccessValue get gendata  "S_dY"]
                set n [GidConvertValueUnit $s_dy]
              set n [ParserNumberUnit $n s_dy unit]

	      set s_dz [GiD_AccessValue get gendata  "S_dZ"]
                set n [GidConvertValueUnit $s_dz]
              set n [ParserNumberUnit $n s_dz unit]

	      set s_col [GiD_AccessValue get gendata  "S_COL"]
	      set s_row [GiD_AccessValue get gendata  "S_ROW"]
	      set s_material_name [GiD_AccessValue get gendata  "SG_Reinforcement_Material"]

	      for {set i 0} {$i < $s_col} {set i [expr $i+1]} {
		  set y [expr $s_py + $s_dy*$i]
		  set z $s_pz
		  for {set j 0} {$j < $s_row} {set j [expr $j+1]} {
		           set z [expr $s_pz + $s_dz*$j]
		           GiD_Process escape escape escape escape geometry create line $s_x1 $y $z $s_x2 $y $z escape escape
		           set last_line_num [GiD_Info Geometry MaxNumLines]

		           set nassigned [GiD_AssignData material $s_material_name lines $last_line_num]
		           set nassigned [GiD_AssignData condition Reinforcement_Nodes_Identification lines $last_line_num]
		           set nassigned [GiD_AssignData condition Reinforcement_Elems_Identification lines $last_line_num]

		           GiD_Process escape escape escape Mesh Structured Lines "1" "$last_line_num" escape escape

		         GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Elems_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
		         GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Nodes_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
		  }
	      }
	      GiD_Process escape escape escape escape utilities variables CreateAlwaysNewPoint $OldCreateAlwaysNewPoint
      } elseif { $afvalue == 1} {
	set OldCreateAlwaysNewPoint [GiD_Info variables CreateAlwaysNewPoint]
	GiD_Process escape escape escape escape utilities variables CreateAlwaysNewPoint 1

	set s_material_name [GiD_AccessValue get gendata  "SAF_Reinforcement_Material"]

	set af_x1 [GiD_AccessValue get gendata  "AF_X1"]
           set n [GidConvertValueUnit $af_x1]
        set n [ParserNumberUnit $n af_x1 unit]

	set af_x2 [GiD_AccessValue get gendata  "AF_X2"]
           set n [GidConvertValueUnit $af_x2]
        set n [ParserNumberUnit $n af_x2 unit]

	set oiy [GiD_AccessValue get gendata  "I_Y"]
           set n [GidConvertValueUnit $oiy]
        set n [ParserNumberUnit $n oiy unit]

	set oiz [GiD_AccessValue get gendata  "I_Z"]
           set n [GidConvertValueUnit $oiz]
        set n [ParserNumberUnit $n oiz unit]

	set oie [GiD_AccessValue get gendata  "I_E"]
           set n [GidConvertValueUnit $oie]
        set n [ParserNumberUnit $n oie unit]

	set ore [GiD_AccessValue get gendata  "R_E"]
           set n [GidConvertValueUnit $ore]
        set n [ParserNumberUnit $n ore unit]

	set pz  [expr $oiz/2.0]
	set dz $oiz
	set py [expr $oiy*3.0/4.0]
	set dy [expr $oiy/2.0]

	# uprostred desek
	if { $oie > [expr $oiz/2.0] } {
		set nz 3
		# samozrejme ze 4, ale 0,1,2,3 je pocet opakovani 4x
	} else {
		set nz 2
		# podobne pocet opakovani od 0 je 3x
	}
	for {set j 0} {$j <= $nz} {set j [expr $j+1]} {
	     set z [expr $pz+$j*$dz]

	     for {set i 0} {$i <= 1} {set i [expr $i+1]} {
		          set y [expr $py + $dy*$i]

		           GiD_Process escape escape escape escape geometry create line $af_x1 $y $z $af_x2 $y $z escape escape
		           set last_line_num [GiD_Info Geometry MaxNumLines]

		           set nassigned [GiD_AssignData material $s_material_name lines $last_line_num]
		           set nassigned [GiD_AssignData condition Reinforcement_Nodes_Identification lines $last_line_num]
		           set nassigned [GiD_AssignData condition Reinforcement_Elems_Identification lines $last_line_num]

		           GiD_Process escape escape escape Mesh Structured Lines "1" "$last_line_num" escape escape

		         GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Elems_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
		         GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Nodes_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
	     }
	}
	set y [expr $oiy/4.0]
	for {set i 0} {$i <= 1} {set i [expr $i+1]} {
		if { $i == 1 } {
		        set z [expr $oiz*2.5 + $oiz*$i]
		} else {
		        set z [expr $oiz*3- ($oiz-$ore)/2.0]
		}

		  GiD_Process escape escape escape escape geometry create line $af_x1 $y $z $af_x2 $y $z escape escape
		  set last_line_num [GiD_Info Geometry MaxNumLines]

		  set nassigned [GiD_AssignData material $s_material_name lines $last_line_num]
		set nassigned [GiD_AssignData condition Reinforcement_Nodes_Identification lines $last_line_num]
		set nassigned [GiD_AssignData condition Reinforcement_Elems_Identification lines $last_line_num]

		  GiD_Process escape escape escape Mesh Structured Lines "1" "$last_line_num" escape escape
		GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Elems_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
		GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Nodes_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
	}

	# na sparach izoalcnich desek

	set y $oiy
	set pz $oiz
	set dz $oiz

	for {set j 0} {$j <= 2} {set j [expr $j+1]} {
	     set z [expr $pz+$j*$dz]

	     GiD_Process escape escape escape escape geometry create line $af_x1 $y $z $af_x2 $y $z escape escape
	     set last_line_num [GiD_Info Geometry MaxNumLines]

	     set nassigned [GiD_AssignData material $s_material_name lines $last_line_num]
	     set nassigned [GiD_AssignData condition Reinforcement_Nodes_Identification lines $last_line_num]
	     set nassigned [GiD_AssignData condition Reinforcement_Elems_Identification lines $last_line_num]

	     GiD_Process escape escape escape Mesh Structured Lines "1" "$last_line_num" escape escape

	     GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Elems_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
	     GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Nodes_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
	}
	     set y [expr $oiy/2.0]
	     set z [expr 3*$oiz]

	     GiD_Process escape escape escape escape geometry create line $af_x1 $y $z $af_x2 $y $z escape escape
	     set last_line_num [GiD_Info Geometry MaxNumLines]

	     set nassigned [GiD_AssignData material $s_material_name lines $last_line_num]
	     set nassigned [GiD_AssignData condition Reinforcement_Nodes_Identification lines $last_line_num]
	       set nassigned [GiD_AssignData condition Reinforcement_Elems_Identification lines $last_line_num]

	     GiD_Process escape escape escape Mesh Structured Lines "1" "$last_line_num" escape escape

	     GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Elems_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape
	     GiD_Process escape escape escape escape Data Conditions CondWindow escape escape escape escape data cond assign Reinforcement_Nodes_Identification change 0 "$last_line_num" escape escape escape escape escape escape escape

	GiD_Process escape escape escape escape utilities variables CreateAlwaysNewPoint $OldCreateAlwaysNewPoint
      }
      return ""
}

proc TK_Initial_Time { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
      set GDN [lindex $args 0]
      set STRUCT [lindex $args 1]
      set QUESTION [lindex $args 2]
      set ivalue [format %d [DWLocalGetValue $GDN $STRUCT "Automatic_Generating_of_Radiation_Function"]]
      set valueunit  [DWLocalGetValue $GDN $STRUCT $QUESTION]
      set value ""
      set unit ""

#     TK_Info $event $args

      if { $ivalue == 1 } {
           set n [GidConvertValueUnit $valueunit]
        set n [ParserNumberUnit $n value unit]

	if {[string is double $value ]} {
		GiD_AccessValue set gendata "CURRENT_TRANSIENT_TIME" $valueunit
	} else {
		   WarnWinText "Could not sync $QUESTION because Initial_Time is not a double value=$value"
	}
      }
      return ""
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
  return ""
}

proc TK_Temp_Discr { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
       set GDN [lindex $args 0]
       set STRUCT [lindex $args 1]
       set QUESTION [lindex $args 2]

#      set ivalue [format %d [GiD_AccessValue get gendata  "Automatic_Generating_of_Radiation_Function"]]
       set ivalue [format %d [DWLocalGetValue $GDN $STRUCT "Automatic_Generating_of_Radiation_Function"]]

#       TK_Info $event $args

	      if { $ivalue == 1 } {
                 set Temp_discr [DWLocalGetValue $GDN $STRUCT $QUESTION]
#                GiD_AccessValue set gendata  "Substep_dT_Size" $Temp_discr
		 DWLocalSetValue $GDN $STRUCT "Substep_dT_Size" $Temp_discr
       }
      return ""
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
}

proc TK_Recalculation_of_harmonic_radiation_func { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
	      set pi 3.14159265358979323846

       set GDN [lindex $args 0]
       set STRUCT [lindex $args 1]
#       set QUESTION [lindex $args 2]
#             set ivalue [format %d [GiD_AccessValue get gendata  "Automatic_Generating_of_Radiation_Function"]]
	      set ivalue [format %d [DWLocalGetValue $GDN $STRUCT "Automatic_Generating_of_Radiation_Function"]]

#       TK_Info $event $args

	      if { $ivalue==1 } {

		 set t_e_midle     [DWLocalGetValue $GDN $STRUCT "t_e_midle3" ]
                   set n [GidConvertValueUnit $t_e_midle]
		 set n [ParserNumberUnit $n t_e_midle unit]

		 set A_e           [DWLocalGetValue $GDN $STRUCT "A_e3"]
                   set n [GidConvertValueUnit $A_e]
		 set n [ParserNumberUnit $n A_e unit]

		 set T_period      [DWLocalGetValue $GDN $STRUCT "T_period"   ]
                   set n [GidConvertValueUnit $T_period]
		 set n [ParserNumberUnit $n T_period unit]

		 set Num_cyc       [format %d [DWLocalGetValue $GDN $STRUCT "Num_cyc"    ]]

		 set Initial_time  [GiD_AccessValue get gendata  "CURRENT_TRANSIENT_TIME"]
                   set n [GidConvertValueUnit $Initial_time]
		 set n [ParserNumberUnit $n Initial_time unit]

		 set Interval1t      [DWLocalGetValue $GDN $STRUCT "Time1_To" ]
                   set n [GidConvertValueUnit $Interval1t]
		 set n [ParserNumberUnit $n Interval1t unit]

		 set Interval2t      [DWLocalGetValue $GDN $STRUCT "Time2_To" ]
                   set n [GidConvertValueUnit $Interval2t]
		 set n [ParserNumberUnit $n Interval2t unit]

		 set Interval3t      [DWLocalGetValue $GDN $STRUCT "Time3_To" ]
                   set n [GidConvertValueUnit $Interval3t]
		 set n [ParserNumberUnit $n Interval3t unit]

		 set Interval4t      [DWLocalGetValue $GDN $STRUCT "Time4_To" ]
                   set n [GidConvertValueUnit $Interval4t]
		 set n [ParserNumberUnit $n Interval4t unit]

		 set T_I3            [expr $Interval3t-$Interval2t ]

		 set ActivInterval1t [DWLocalGetValue $GDN $STRUCT "Function_Interval_1" ]
		 set ActivInterval2t [DWLocalGetValue $GDN $STRUCT "Function_Interval_2" ]
		 set ActivInterval3t [DWLocalGetValue $GDN $STRUCT "Function_Interval_3" ]
		 set ActivInterval4t [DWLocalGetValue $GDN $STRUCT "Function_Interval_4" ]

		 set Temp_discr    [DWLocalGetValue $GDN $STRUCT "Temp_discr" ]
                   set n [GidConvertValueUnit $Temp_discr]
		 set n [ParserNumberUnit $n Temp_discr unit]

#                GiD_AccessValue set gendata  "Substep_dT_Size" $Temp_discr
		 DWLocalSetValue $GDN $STRUCT "Substep_dT_Size" [format %g%s $Temp_discr $unit]

		 if { $Num_cyc==1 } {
		         # WarnWinText "$ActivInterval4t, $ActivInterval3t, $ActivInterval2t, $ActivInterval1t"

		         if { $ActivInterval4t==1 } {
		                set T_period $Interval4t
		         } elseif { $ActivInterval3t==1 } {
		                set T_period $Interval3t
		         } elseif { $ActivInterval2t==1 } {
		                set T_period $Interval2t
		         } elseif { $ActivInterval1t==1 } {
		                set T_period $Interval1t
		         }
		 }
		 set dt        [expr $T_I3/2.0/(double($A_e)/double($Temp_discr))]
#		 set dt        [expr $T_period/4.0/(double($A_e)/double($Temp_discr))]
#                set dt        [expr $T_period/(2*$pi)/double((double($A_e)/double($Temp_discr))]
		 set n_period  [expr int($T_period/double($dt))]
#                WarnWinText "n_period=$n_period"
		 set dt        [expr $T_period/$n_period]
#                WarnWinText "dt=$dt"
		 set ni        [expr int($n_period*$Num_cyc)+1]
#                WarnWinText "ni=$ni"

		 set T_period      [DWLocalGetValue $GDN $STRUCT "T_period"   ]
                   set n [GidConvertValueUnit $T_period]
		 set n [ParserNumberUnit $n T_period unit]

		 set omega     [expr 2*$pi/double($T_period)]
#                WarnWinText "omega=$omega"

		 set tvalue "#N# [format %d [expr ($ni-1)*3]] "

		 for {set i 1} {$i < $ni} {set i [expr $i+1]} {

		         set time [expr $dt*$i]

		         if { $i == [expr $ni-1] } {
		                set time [expr $T_period*$Num_cyc]

		                if { $Num_cyc==1 && $ActivInterval4t==1 && $Interval4t<=$T_period } {
		                              set time $Interval4t
		                 } elseif { $Num_cyc==1 && $ActivInterval3t==1 && $Interval3t<=$T_period } {
		                        set time $Interval3t
		                 } elseif { $Num_cyc==1 && $ActivInterval2t==1 && $Interval2t<=$T_period } {
		                        set time $Interval2t
		                 } elseif { $Num_cyc==1 && $ActivInterval1t==1 && $Interval1t<=$T_period } {
		                        set time $Interval1t
		                 }
		         }

    set i_cyc [expr int([format %g [expr $time/double($T_period)]])]
#    WarnWinText "i_cyc1=$i_cyc"
    set i_cyc [expr $i_cyc*1]
#    WarnWinText "i_cyc2=$i_cyc"

#    WarnWinText "$time, 1...[expr $Interval1t+($i_cyc*$T_period)]"
#    WarnWinText "$time, 2...[expr $Interval2t+($i_cyc*$T_period)]"
#    WarnWinText "$time, 3...[expr $Interval3t+($i_cyc*$T_period)]"
#    WarnWinText "$time, 4...[expr $Interval4t+($i_cyc*$T_period)]"

		  if { $time <= [expr $Interval1t+($i_cyc*$T_period)] } {

		          set Time_of_Maximum [DWLocalGetValue $GDN $STRUCT "Time1_of_Maximum" ]
                            set n [GidConvertValueUnit $Time_of_Maximum]
                          set n [ParserNumberUnit $n Time_of_Maximum unit]

		          set t_e_midle       [DWLocalGetValue $GDN $STRUCT "t_e_midle1"       ]
                            set n [GidConvertValueUnit $t_e_midle]
                          set n [ParserNumberUnit $n t_e_midle unit]

		          set A_e             [DWLocalGetValue $GDN $STRUCT "A_e1"             ]
                            set n [GidConvertValueUnit $A_e]
                          set n [ParserNumberUnit $n A_e unit]

#                         WarnWinText "1: $time, [expr $Interval1t+($i_cyc*$T_period)]"
		  } elseif { $time < [expr $Interval2t+($i_cyc*$T_period)] } {

		          set Time_of_Maximum [DWLocalGetValue $GDN $STRUCT "Time2_of_Maximum" ]
                            set n [GidConvertValueUnit $Time_of_Maximum]
                          set n [ParserNumberUnit $n Time_of_Maximum unit]

		          set t_e_midle       [DWLocalGetValue $GDN $STRUCT "t_e_midle2"       ]
                            set n [GidConvertValueUnit $t_e_midle]
                          set n [ParserNumberUnit $n t_e_midle unit]

		          set A_e             [DWLocalGetValue $GDN $STRUCT "A_e2"             ]
                            set n [GidConvertValueUnit $A_e]
                          set n [ParserNumberUnit $n A_e unit]

#                         WarnWinText "2: $time, [expr $Interval2t+($i_cyc*$T_period)] "
		  } elseif { $time < [expr $Interval3t+($i_cyc*$T_period)] } {

		          set Time_of_Maximum [DWLocalGetValue $GDN $STRUCT "Time3_of_Maximum" ]
                            set n [GidConvertValueUnit $Time_of_Maximum]
                          set n [ParserNumberUnit $n Time_of_Maximum unit]

		          set t_e_midle       [DWLocalGetValue $GDN $STRUCT "t_e_midle3"       ]
                            set n [GidConvertValueUnit $t_e_midle]
                          set n [ParserNumberUnit $n t_e_midle unit]

		          set A_e             [DWLocalGetValue $GDN $STRUCT "A_e3"             ]
                            set n [GidConvertValueUnit $A_e]
                          set n [ParserNumberUnit $n A_e unit]

#                         WarnWinText "3: $time, [expr $Interval3t+($i_cyc*$T_period)]"
		  } elseif { $time <= [expr $Interval4t+($i_cyc*$T_period)] } {

		          set Time_of_Maximum [DWLocalGetValue $GDN $STRUCT "Time4_of_Maximum" ]
                            set n [GidConvertValueUnit $Time_of_Maximum]
                          set n [ParserNumberUnit $n Time_of_Maximum unit]

		          set t_e_midle       [DWLocalGetValue $GDN $STRUCT "t_e_midle4"       ]
                            set n [GidConvertValueUnit $t_e_midle]
                          set n [ParserNumberUnit $n t_e_midle unit]

		          set A_e             [DWLocalGetValue $GDN $STRUCT "A_e4"             ]
                            set n [GidConvertValueUnit $A_e]
                          set n [ParserNumberUnit $n A_e unit]

#                         WarnWinText "4: $time, [expr $Interval4t+($i_cyc*$T_period)]"
		  }

		  set fvalue [expr $t_e_midle + $A_e*cos($omega*($time-$Time_of_Maximum))]
		      set tvalue "$tvalue $time $fvalue 1"
#                 WarnWinText "time=$time, fvalue=$fvalue, $t_e_midle, $A_e, $Time_of_Maximum, $ni, $i"
		 }
#                WarnWinText "nRows=$ni"
	       # WarnWinText "tvalue=$tvalue"
#                GiD_AccessValue set gendata  "Radiation" $tvalue
		 DWLocalSetValue $GDN $STRUCT "Radiation" $tvalue
       }
      return ""
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
}

proc TK_Switch_Automaci_Substeping { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
       set GDN [lindex $args 0]
       set STRUCT [lindex $args 1]
       set QUESTION [lindex $args 2]
#       WarnWinText "QUESTION =$QUESTION "

	      set ivalue [format %g [DWLocalGetValue $GDN $STRUCT $QUESTION]]
#             set ivalue [format %g [GiD_AccessValue get gendata  "Automatic_Generating_of_Radiation_Function"]]
#       WarnWinText "value =$ivalue "

	      if { $ivalue == 1 } {
#                GiD_AccessValue set gendata  "Automatic_Substeping" 0
		 DWLocalSetValue $GDN $STRUCT "Automatic_Substeping" 0
       }
      return ""
    }
    CLOSE {
      # do nothing here
      return ""
    }
  }
}

proc TK_Modify_Layer { event args } {
  switch $event {
    INIT {
	# do nothing here
	return ""
    }
    SYNC {
      set GDN [lindex $args 0]
      set STRUCT [lindex $args 1]
      set QUESTION [lindex $args 2]

#      WarnWinText "TK_Modify_Layer G S Q"
#      WarnWinText $GDN
#      WarnWinText $STRUCT
#      WarnWinText $QUESTION

#      set layer2 [DWLocalGetValue $GDN $STRUCT $QUESTION]
#      WarnWinText $layer2

      set sw_gen [GiD_AccessValue get gendata "sw_GenerateMacroelem"]
      set LayerValues [GiD_AccessValue get gendata "Layer"]
      set bLayerValues [GiD_AccessValue get gendata "Backup_Layer"]
      set nLayers [Get_nLayers ]

#      WarnWinText $sw_gen
#      WarnWinText $LayerValues
#      WarnWinText $bLayerValues
      GiD_AccessValue set gendata "Backup_Layer" $LayerValues

      set Advanced_check [DWLocalGetValue $GDN $STRUCT "_Advanced_Frame"]
      if { $Advanced_check == 1 } {
	      set kryti [DWLocalGetValue $GDN $STRUCT "AF_X1"]
                set n [GidConvertValueUnit $kryti]
              set n [ParserNumberUnit $n kryti unit]
	      set CalcLength [DWLocalGetValue $GDN $STRUCT "Calc_Length"]
	      if { $CalcLength == 1 } {
		        set delka [expr [lindex $LayerValues 2]+[lindex $LayerValues 6]+[lindex $LayerValues 10] - $kryti]
		    if { $nLayers > 3 } {
		      set delka [expr $delka + 0.5*[lindex $LayerValues 14]]
		  }
		  DWLocalSetValue $GDN $STRUCT "Dowel_Length" [format %g%s $delka $unit]
	      } else {
		        set delka [DWLocalGetValue $GDN $STRUCT "Dowel_Length"]
	                  set n [GidConvertValueUnit $delka]
                        set n [ParserNumberUnit $n delka unit]
	      }
	      set X2 [expr $kryti + $delka]
	      # GiD_AccessValue set gendata "AF_X2" $X2
	      DWLocalSetValue $GDN $STRUCT "AF_X2" [format %g%s $X2 $unit]
      } else {
	      set kryti [GiD_AccessValue get gendata "S_X1"]
                set n [GidConvertValueUnit $kryti]
	      set n [ParserNumberUnit $n kryti unit]
	      set delka [expr [lindex [GiD_AccessValue get gendata "Layer"] 2]+[lindex [GiD_AccessValue get gendata "Layer"] 6]+[lindex [GiD_AccessValue get gendata "Layer"] 10] - $kryti]
	      set X2 [format %g%s [expr $kryti + $delka] $unit]
	      # GiD_AccessValue set gendata "S_X2" $X2
	      DWLocalSetValue $GDN $STRUCT "S_X2" $X2
      }

#     v pripade ze konstrukce neni nagenerovana...
#       pouze se ulozi Layer to Backup_Layer
#
#      WarnWinText "layer  = $LayerValues "
#      WarnWinText "blayer = $bLayerValues "

      set podm [string equal $LayerValues  $bLayerValues ]
#      WarnWinText "pred podminkou: $podm "
      if {$podm != 1} {
#               WarnWinText "neni stejny backup jako original"
		GiD_AccessValue set gendata "Backup_Layer" $LayerValues
#               v pripade ze konstrukce je nagenerovana...

#               if { $sw_gen==0 } {
##                      WarnWinText "a navic byla konstrukce jiz nagenerovana"
##                      v pripade ze "Backup_Layer" != "Layer"
##
#                       Delete_Sandwich3D_Geometry
#                       Generate_Sandwich3D_With_Material_And_BC
#               }
      }
      set LayerNumCells [lindex $LayerValues 1]
      set InitTemp_ExtLayer [format %g [lindex $LayerValues [expr $LayerNumCells+0]]]
#      WarnWinText "InitTemp_ExtLayer = $InitTemp_ExtLayer, LayerNumCells = $LayerNumCells"

      for {set i 4} {$i <= [expr $LayerNumCells+1]} {set i [expr $i+4]} {
	       set indexLayer [expr ($i-1)/4.0]
	       set poziceMat  [expr $i-1]
	       set InitialTemp [lindex $LayerValues $i]
	       set matName [lindex $LayerValues $poziceMat]
	       set thickness [lindex $LayerValues [expr $poziceMat-1]]

#              WarnWinText "i= $i, matName= $matName, InitialTemp= $InitialTemp"
	       set nassigned  [GiD_AccessValue set materials $matName "Temperature_CONST" $InitialTemp]
	       if { $nassigned <= 0 } {
		        WarnWinText "WARNING: Modification of Initial Temperature of material layer $indexLayer is it to 0 failed!"
	       }
	       Reset_Reinforceing_RATIO $matName $thickness
      }
      return ""
    }
    CLOSE {
	# do nothing here
	return ""
    }
  }
}

proc Reset_Reinforceing_RATIO { matName thickness } {

     # WarnWinText "Reset_Reinforceing_RATIO: $matName $thickness"

	       if { $matName == "OrthoReinforced_Adhesive" } {
		     set  lReinfMaterials "OrthoReinforced_Adhesive Reinforced_Adhesive_Z Reinforced_Adhesive_Y Reinforced_Adhesive_YZ_and_45st Reinforced_Adhesive_45st_only"
		     set nlReinfMaterials [llength $lReinfMaterials]
		            for { set k 0 } { $k < $nlReinfMaterials } { set k [expr $k+1] } {
		                  set lmat [lindex $lReinfMaterials $k]

		           set CompRATIO "Reinf_01_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_01_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $lmat $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $lmat $pCompRATIOAsAc  $newvalue

		           set CompRATIO "Reinf_02_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_02_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $lmat $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $lmat $pCompRATIOAsAc  $newvalue

		           set CompRATIO "Reinf_03_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_03_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $lmat $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $lmat $pCompRATIOAsAc  $newvalue
		     }
	       } elseif { $matName == "IzoReinforced_Adhesive" } {
		           set CompRATIO "Reinf_01_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_01_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $matName $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $matName $pCompRATIOAsAc  $newvalue

		           set CompRATIO "Reinf_02_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_02_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $matName $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $matName $pCompRATIOAsAc  $newvalue

		           set CompRATIO "Reinf_03_Reinforcing_RATIO_1mm2"
		           set pCompRATIOAsAc "Reinf_03_Reinforcing_RATIO_p=As/Ac"
		           set ReinforcingRATIO1mm [GiD_AccessValue get materials $matName $CompRATIO]
		           set newvalue [expr $ReinforcingRATIO1mm/double($thickness*1000)]
		           TK_setMaterialParam $matName $pCompRATIOAsAc $newvalue
	       }
     return ""
}

proc TK_setMaterialParam { matName CompRATIO value } {

    # WarnWinText "$matName $CompRATIO $value"
    set nassigned  [GiD_AccessValue set materials $matName $CompRATIO $value]
    if { $nassigned <= 0 } {
	WarnWinText "WARNING: Modification of $CompRATIO of material $matName it is 0 failed!"
    }
}

proc TK_Modify_Temp_First_Increment_Radiation { event args } {
  switch $event {
    INIT {
	# do nothing here
	return ""
    }
    SYNC {
        set Increment_Values [GiD_AccessValue get gendata "Increment_Radiation"]
        WarnWinText "Increment_Values= $Increment_Values"
    }
    CLOSE {
        # do nothing here
        return ""
    }
  }
}

proc TK_Modify_Incremental_Radiation { event args } {
  switch $event {
    INIT {
      # do nothing here
      return ""
    }
    SYNC {
      set GDN [lindex $args 0]
      set STRUCT [lindex $args 1]
      set QUESTION [lindex $args 2]

      set array_values [GiD_AccessValue get gendata "Radiation"]
      set NumCells [lindex $array_values 1]
#     WarnWinText $NumCells

      set array_incr_values [list "#N#" $NumCells]

      set sw_Automatic_Substeping [GiD_AccessValue get gendata "Automatic_Substeping"]
      set Substep_dT_Size [GiD_AccessValue get gendata "Substep_dT_Size"]
        set n [GidConvertValueUnit $Substep_dT_Size]
      set n [ParserNumberUnit $n Substep_dT_Size unit]

      set a_Substep [lindex $array_values 4]

#     for {set i 0} {$i <= $NumCells} {set i [expr $i+1]} {
#        WarnWinText [lindex $NumCells $i]
#     }
      set LayerValues [GiD_AccessValue get gendata "Layer"]
      set LayerNumCells [lindex $LayerValues 1]

      set InitTemp_ExtLayer [lindex $LayerValues [expr $LayerNumCells]]
#      WarnWinText "InitTemp_ExtLayer= $InitTemp_ExtLayer"

      set dx [format %16.7lf       [lindex $array_values 2]]
      set dy [format %16.7lf [expr [lindex $array_values 3] - $InitTemp_ExtLayer]]
#      WarnWinText "dx = $dx, dy = $dy"

      if { $sw_Automatic_Substeping == 1 } {
		lappend array_incr_values $dx $dy [expr abs(int([expr $dy/double($Substep_dT_Size)]))*1]
      } else {
		lappend array_incr_values $dx $dy [expr abs(int($a_Substep))*1]
      }

      for {set i 2} {$i <= [expr $NumCells-2]} {set i [expr $i+3]} {
	set valX1 [lindex $array_values $i]
	set valX2 [lindex $array_values [expr $i+3]]
	set valY1 [expr [lindex $array_values [expr $i+1]] + 0.0]
	set valY2 [expr [lindex $array_values [expr $i+4]] + 0.0]
	set a_Substep [lindex $array_values [expr $i+5]]

	set dx [format %16.7lf [expr $valX2-$valX1]]
#        WarnWinText $dx

	set dy [format %16.7lf [expr $valY2-$valY1]]
#        WarnWinText $dy
	if { $sw_Automatic_Substeping == 1 } {
		lappend array_incr_values $dx $dy [expr abs(int([expr $dy/double($Substep_dT_Size)]))*1]
	} else {
		lappend array_incr_values $dx $dy [expr abs(int($a_Substep))*1]
	}
      }
#      WarnWinText $array_incr_values

      set sw_gen [GiD_AccessValue set gendata "Increment_Radiation" $array_incr_values]

#      WarnWinText $array_incr_values
      return ""
    }
    CLOSE {
       # do nothing here
       return ""
    }
  }
  return ""
}

proc Counting_Of_Macroelement { } {
   set oMacroelementCount [GiD_AccessValue get gendata MacroelementCount]
#   WarnWinText "proc Counting_Of_Macroelement"
#   WarnWinText $oMacroelementCount

   GiD_AccessValue set gendata MacroelementCount [expr $oMacroelementCount+1]
#   WarnWinText [GiD_AccessValue get gendata MacroelementCount]
}

proc Assign_Volume_Structures { } {
#    GiD_Process escape escape escape Mesh Structured Volumes layer:Layer0 escape 4 Assign escape escape escape escape
#    Meshing AssignSizes Volumes
#    GiD_Process escape escape escape Mesh Structured Volumes layer:Layer0 escape 1 layer:Layer0 escape 1 escape escape
#    GiD_Process escape escape escape escape Meshing Structured Surfaces 1: escape escape

     GiD_Process escape escape escape Mesh Structured Volumes 1: escape escape
     GiD_Process escape escape escape escape Meshing ElemType Hexahedra 1: escape escape
}

proc Division_By_Size { } {

      set Size_or_division [GiD_AccessValue get gendata "Size_Or_Division"]
      if { $Size_or_division == 0} {
       return ""
      }

      set Size_Y [GiD_AccessValue get gendata "Size_Y"]
      set Size_Z [GiD_AccessValue get gendata "Size_Z"]
      
        set n [GidConvertValueUnit $Size_Y]
      set n [ParserNumberUnit $n Size_Y unit]
      
        set n [GidConvertValueUnit $Size_Z]
      set n [ParserNumberUnit $n Size_Z unit]

      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set nLayers [Get_nLayers ]

      set NumMacr [GiD_AccessValue get gendata "MacroelementCount"]
      set nSandwic [expr $NumMacr / double($nLayers)]

      set IPreviousMacrID 0
      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {
	# set layer_name "Division_$i"
	# GiD_Process escape escape escape escape view layers new $layer_name escape

	set Div_X [lindex $valuesLayer [expr 1+4+($i-1)*4]]

	for {set j 1} {$j <= $nSandwic} {set j [expr $j+1]} {

	     set ICurrentMacrID  [expr ($j-1)*$nLayers+$i]
	     set IPreviousMacrID [expr $ICurrentMacrID-1]

	     set ID_lines ""
	     for {set k 1} {$k <= 7} {set k [expr $k+2]} {
		 # iDiv_X 1,3,5,7
		 # setting of division in direction X
		   lappend ID_lines [expr $IPreviousMacrID*12+$k]
	     }
	     GiD_Process escape escape escape Mesh Structured Lines $Div_X $ID_lines escape escape

	     set ID_lines ""
	     for {set k 2} {$k <= 8} {set k [expr $k+2]} {
		 # setting of division in direction Y
		 # iDiv_Y 2,4,6,8
		   set ID_lines [expr $IPreviousMacrID*12+$k]
		   Assign_One_line_division_By_Size $Size_Y $ID_lines
	     }

	     set ID_lines ""
	     for {set k 9} {$k <= 12} {set k [expr $k+1]} {
		 # setting of division in direction Z
		 # iDiv_Z 9,10,11,12
		   set ID_lines [expr $IPreviousMacrID*12+$k]
		   Assign_One_line_division_By_Size $Size_Z $ID_lines
	     }
	}
	# GiD_Process escape escape escape escape view layers delete $layer_name escape
      }
      return ""
}

proc Assign_One_line_division_By_Size { elementsize num } {

      set info [GiD_Info list_entities -more line $num]
      regexp {Length=(\S+)} $info dummy length

#        set n [GidConvertValueUnit $length]
      set n [ParserNumberUnit $length length unit]
      
      set ndiv [expr {int($length/double($elementsize))}]
      # set inum [format %d $num]
      set inum [expr int($num)]
      if { $ndiv < 1 } {
	 set ndiv 1
      }
      GiD_Process escape escape escape escape Meshing Structured Lines $ndiv $inum escape escape
}

proc Gap_Interfaces_for_Advanced_Frame { } {

     set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
     if { $adv_frm != "Advanced_Frame_Panel"} {
	return ""
     }

     set valuesLayer [GiD_AccessValue get gendata "Layer"]
     set nLayers [Get_nLayers ]

     if { $nLayers < 3 } {
	    return ""
     }
     set layer_name "Contacts_for_Insulation"
     GiD_Process layer new $layer_name escape

     # -----------------
     # svisle kontakty
     set Sandwich_num_contact1 "28  24  129 121 113 105 97 89 81 49 41 33"
     set Sandwich_num_contact2 "141 133 130 122 114 106 98 90 82 50 42 34"
     set nContacts 12

     GiD_AccessValue set gendata "ContactCount" [GiD_AccessValue get gendata "MacroelementCount"]
     set ContactCount [GiD_AccessValue get gendata "ContactCount"]
     for { set i 1 } { $i <= $nContacts } { set i [expr $i+1] } {

	     set send1 [lindex $Sandwich_num_contact1 [expr $i-1]]
	     set send2 [lindex $Sandwich_num_contact2 [expr $i-1]]

	set vol1  [expr $nLayers*($send1-1) +3]
	set vol2  [expr $nLayers*($send2-1) +3]
#        WarnWinText "vol1=$vol1, vol2=$vol2"

	set surf1 [expr $vol1 *6-2]
	set surf2 [expr $vol2 *6-4]

	     GiD_Process escape escape escape escape geometry create contact volume $surf1 $surf2 escape
	     set vol_num [expr $ContactCount+$i]
	     GiD_Process escape escape escape escape data mat assign CC3DInterface Volumes $vol_num escape escape escape escape escape escape escape escape escape escape escape escape
	     GiD_Process layer entities $layer_name LowerEntities Volumes $vol_num escape escape escape escape
     }
     GiD_AccessValue set gendata "ContactCount" $vol_num

     # -----------------
     # vodorovne kontakty
     set Sandwich_num_contact1 "21 22 23 24 133 134 135 136 137 138 139 140 77 78 79 80 81 82 83 84 53 54 55 56 57 58 59 60"
     set Sandwich_num_contact2 "17 18 19 20 125 126 127 128 129 130 131 132 69 70 71 72 73 74 75 76 45 46 47 48 49 50 51 52"
     set nContacts 28

     set ContactCount [GiD_AccessValue get gendata "ContactCount"]
     for { set i 1 } { $i <= $nContacts } { set i [expr $i+1] } {

	     set send1 [lindex $Sandwich_num_contact1 [expr $i-1]]
	     set send2 [lindex $Sandwich_num_contact2 [expr $i-1]]

	set vol1  [expr $nLayers*($send1-1) +3]
	set vol2  [expr $nLayers*($send2-1) +3]
#        WarnWinText "vol1=$vol1, vol2=$vol2"

	set surf1 [expr $vol1 *6-5]
	set surf2 [expr $vol2 *6  ]

	     GiD_Process escape escape escape escape geometry create contact volume $surf1 $surf2 escape escape
	     set vol_num [expr $ContactCount+$i]
	     GiD_Process escape escape escape escape data mat assign CC3DInterface Volumes $vol_num escape escape escape escape
	     GiD_Process layer entities $layer_name LowerEntities Volumes $vol_num escape escape escape escape
     }
     GiD_AccessValue set gendata "ContactCount" $vol_num

#     set contact_volume_list [GiD_Info layers -entities Volumes $layer_name]
#      $contact_volume_list
}

proc PrepareMesh_For_StaticExport { } {
     GiD_AccessValue set gendata Calculation_Analysis SandwichStatic3D
#    GiD_AccessValue set gendata Type_Analysis STATIC

     set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
     if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	     set text "Data for Static Analysis are OK!"
	     tk_messageBox -icon info -title [_ "Info:"] -type ok \
			   -message "$text"
	return ""
     }
     
     GiD_Process escape escape escape escape Meshing CancelMesh
	
     set nIntervals [GiD_Info IntvData NUM]
     for { set i 2 } { $i <= $nIntervals } { set i [expr $i+1] } {
	GiD_IntervalData set $i
	UnAssign_Condition "Elements_Activity_for_Volume"
     }
     GiD_IntervalData set 1
     Assign_Elements_for_BC_Deleting
     GiD_Process escape escape escape escape Meshing Generate

     set text "Regeneration was OK!"
     tk_messageBox -icon info -title [_ "Info:"] -type ok \
		   -message "$text"
}

proc PrepareMesh_For_TempExport { } {

     GiD_AccessValue set gendata Calculation_Analysis SandwichTemperature3D
#    GiD_AccessValue set gendata Type_Analysis TRANSIENT

     set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
     if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	     set text "Data for Transport Analysis are OK!"
	     tk_messageBox -icon info -title [_ "Info:"] -type ok \
			   -message "$text"
	return ""
     }
#
#   set cIntervals [GiD_Info IntvData NUM]
#   set cnd "Fixed_Contact_for_Surface"
#   for { set i 1 } { $i <= $cIntervals } { set i [expr $i+1] }
#        GiD_IntervalData set $i
#        UnAssign_Condition "Fixed_Contact_for_Surface"
##        GiD_Process escape escape escape escape data cond assign $cnd delete y escape escape
#
#
     set element_list [GiD_Info layers -entities elements Contacts_for_Insulation]
#    eval GiD_Mesh delete element $element_list escape escape escape escape
     eval GiD_Process escape escape escape escape Meshing EditMesh DeleteElems $element_list escape escape escape escape
#
     GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 0
     GiD_Process escape escape escape escape Utilities Variables ImportTolerance 1e-4
       GiD_Process escape escape escape escape utilities Collapse mesh Yes
     GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 1

     set text "Collapse was OK!"
     tk_messageBox -icon info -title [_ "Info:"] -type ok \
		   -message "$text"
}

proc Delete_Duplicit_Macroelements { } {

     set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
     if { $adv_frm != "Advanced_Frame_Panel"} {
	return ""
     }

     set valuesLayer [GiD_AccessValue get gendata "Layer"]
     set nLayers [Get_nLayers ]

#     if { $nLayers < 3 } {
#            return ""
#     }

     for { set i 1 } { $i <= $nLayers } { set i [expr $i+1] } {

	GiD_Process escape escape escape escape geometry delete volume [expr 28*$nLayers+$i] escape
	GiD_Process escape escape escape escape geometry delete volume [expr 29*$nLayers+$i] escape
	GiD_Process escape escape escape escape geometry delete volume [expr 30*$nLayers+$i] escape
	GiD_Process escape escape escape escape geometry delete volume [expr 31*$nLayers+$i] escape
     }
     GiD_Process escape escape escape escape geometry delete surface 1: escape
     GiD_Process escape escape escape escape geometry delete line    1: escape
     GiD_Process escape escape escape escape geometry delete point   1: escape
}

proc Division_On_Lines { } {

      set Size_or_division [GiD_AccessValue get gendata "Size_Or_Division"]
      if { $Size_or_division == 1} {
       return ""
      }

      set Div_Y [GiD_AccessValue get gendata "Division_Y"]
      set Div_Z [GiD_AccessValue get gendata "Division_Z"]

      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set nLayers [Get_nLayers ]

      set NumMacr [GiD_AccessValue get gendata "MacroelementCount"]
      set nSandwic [expr $NumMacr / double($nLayers)]

      set IPreviousMacrID 0
      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {
	# set layer_name "Division_$i"
	# GiD_Process escape escape escape escape view layers new $layer_name escape

	set Div_X [lindex $valuesLayer [expr 1+4+($i-1)*4]]

	for {set j 1} {$j <= $nSandwic} {set j [expr $j+1]} {

	     set ICurrentMacrID  [expr ($j-1)*$nLayers+$i]
	     set IPreviousMacrID [expr $ICurrentMacrID-1]

	     set lines_DirX_List ""
	     for {set k 1} {$k <= 7} {set k [expr $k+2]} {
		 # iDiv_X 1,3,5,7
		 # setting of division in direction X
		   set ID_linie [expr $IPreviousMacrID*12+$k]
		   lappend lines_DirX_List $ID_linie

		 # "Assign number of cells"
		 # Meshing AssignSizes Lines
		 # Meshing Structured Lines
	     }
	     GiD_Process escape escape escape Mesh Structured Lines $Div_X $lines_DirX_List escape escape

	     set lines_DirY_List ""
	     for {set k 2} {$k <= 8} {set k [expr $k+2]} {
		 # setting of division in direction Y
		 # iDiv_Y 2,4,6,8
		   set ID_linie [expr $IPreviousMacrID*12+$k]
		lappend lines_DirY_List $ID_linie
	     }
	     GiD_Process escape escape escape Mesh Structured Lines $Div_Y $lines_DirY_List escape escape

	     set lines_DirZ_List ""
	     for {set k 9} {$k <= 12} {set k [expr $k+1]} {
		 # setting of division in direction Z
		 # iDiv_Z 9,10,11,12
		   set ID_linie [expr $IPreviousMacrID*12+$k]
		lappend lines_DirZ_List $ID_linie
	     }
	     GiD_Process escape escape escape Mesh Structured Lines $Div_Z $lines_DirZ_List escape escape
	}
	# GiD_Process escape escape escape escape view layers delete $layer_name escape
      }
}
proc Get_nLayers {} {
      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set LayerNumCells [lindex $valuesLayer 1]
      set nLayers [expr $LayerNumCells / 4.0]
      return $nLayers
}
proc Slave_LayerNum { iLayer } {
# iLayer 0 - internal surface of concrete
# iLayer je spara a tudiz je vzdy Slave 2*i

      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
      if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   return ""
      }

      set nLayers [Get_nLayers ]

      set cs_surfaces ""
      for { set i 1 } { $i <= 148} {set i [expr $i+1]} {
		  set js_macr [expr $nLayers*($i-1)+($iLayer)]
	    set cs_surfaces "$cs_surfaces [expr $js_macr*6+5]"
      }
      return $cs_surfaces
}

proc Master_LayerNum { iLayer } {
# iLayer 0 - internal surface of concrete
# iLayer je spara a tudiz je vzdy Master 2*i-1

      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
      if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   return ""
      }

      set nLayers [Get_nLayers ]

      set cm_surfaces ""
      for { set i 1 } { $i <= 148} {set i [expr $i+1]} {
		  set jm_macr [expr $nLayers*($i-1)+($iLayer-1)]
	    set cm_surfaces "$cm_surfaces [expr $jm_macr*6+3]"
      }
      return $cm_surfaces
}

proc MasterSlave_GapNum { iLayer } {

      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
      if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   return ""
      }

      set nLayers [Get_nLayers ]
      if { $iLayer >= $nLayers } {
	 return ""
      }

      set cm_surfaces [Master_LayerNum $iLayer]
      set cs_surfaces [Slave_LayerNum  $iLayer]

#      WarnWinText "cm_surfaces =$cm_surfaces"
#      WarnWinText "cs_surfaces =$cs_surfaces"

      # iLayer = 2
      # Slave "15 51 87 123 159 195 231 267 303 339 375 411 447 483 519 555 591 627 663 699 735 771 807 843 879 915 951 987 1023 1059 1095 1131 1167 1203 1239 1275 1311 1347 1383 1419 1455 1491 1527 1563 1599 1635 1671 1707 1743 1779 1815 1851 1887 1923 1959 1995 2031 2067 2103 2139 2175 2211 2247 2283 2319 2355 2391 2427 2463 2499 2535 2571 2607 2643 2679 2715 2751 2787 2823 2859 2895 2931 2967 3003 3039 3075 3111 3147 3183 3219 3255 3291 3327 3363 3399 3435 3471 3507 3543 3579 3615 3651 3687 3723 3759 3795 3831 3867 3903 3939 3975 4011 4047 4083 4119 4155 4191 4227 4263 4299 4335 4371 4407 4443 4479 4515 4551 4587 4623 4659 4695 4731 4767 4803 4839 4875 4911 4947 4983 5019 5055 5091 5127 5163 5199 5235 5271 5307 17 53 89 125 161 197 233 269 305 341 377 413 449 485 521 557 593 629 665 701 737 773 809 845 881 917 953 989 1025 1061 1097 1133 1169 1205 1241 1277 1313 1349 1385 1421 1457 1493 1529 1565 1601 1637 1673 1709 1745 1781 1817 1853 1889 1925 1961 1997 2033 2069 2105 2141 2177 2213 2249 2285 2321 2357 2393 2429 2465 2501 2537 2573 2609 2645 2681 2717 2753 2789 2825 2861 2897 2933 2969 3005 3041 3077 3113 3149 3185 3221 3257 3293 3329 3365 3401 3437 3473 3509 3545 3581 3617 3653 3689 3725 3761 3797 3833 3869 3905 3941 3977 4013 4049 4085 4121 4157 4193 4229 4265 4301 4337 4373 4409 4445 4481 4517 4553 4589 4625 4661 4697 4733 4769 4805 4841 4877 4913 4949 4985 5021 5057 5093 5129 5165 5201 5237 5273 5309"
      set cond Fixed_Contact_for_Surface
      set values "Slave Contact 2 0"
      set nassigned  [eval "GiD_AssignData condition $cond surfaces {$values} {$cs_surfaces}"]
      if { $nassigned <= 0 } {
	   WarnWinText "WARNING: condition can not be assigned for surfaces $cs_surfaces"
      }

      # iLayer = 2
      # Master "9 23 45 59 81 95 117 131 153 167 189 203 225 239 261 275 297 311 333 347 369 383 405 419 441 455 477 491 513 527 549 563 585 599 621 635 657 671 693 707 729 743 765 779 801 815 837 851 873 887 909 923 945 959 981 995 1017 1031 1053 1067 1089 1103 1125 1139 1161 1175 1197 1211 1233 1247 1269 1283 1305 1319 1341 1353 1355 1377 1379 1391 1413 1427 1449 1463 1485 1499 1521 1535 1557 1571 1593 1607 1629 1643 1665 1679 1701 1715 1737 1751 1773 1787 1809 1823 1845 1859 1881 1895 1917 1931 1953 1967 1989 2003 2025 2039 2061 2075 2097 2111 2133 2147 2169 2183 2205 2219 2241 2255 2277 2291 2313 2327 2349 2363 2385 2399 2421 2435 2457 2471 2493 2507 2529 2543 2565 2579 2601 2615 2637 2651 2673 2687 2709 2723 2745 2759 2781 2795 2817 2831 2853 2867 2889 2903 2925 2939 2961 2975 2997 3011 3033 3047 3069 3083 3105 3119 3141 3155 3177 3191 3213 3227 3249 3263 3285 3299 3321 3335 3357 3371 3393 3407 3429 3443 3465 3479 3501 3515 3537 3551 3573 3587 3609 3623 3645 3659 3681 3695 3717 3731 3753 3767 3789 3803 3825 3839 3861 3875 3897 3911 3933 3947 3969 3983 4005 4019 4041 4055 4077 4091 4113 4127 4149 4163 4185 4199 4221 4235 4257 4271 4293 4307 4329 4343 4365 4379 4401 4415 4437 4451 4473 4487 4509 4523 4545 4559 4581 4595 4617 4631 4653 4667 4689 4703 4725 4739 4761 4775 4797 4811 4833 4847 4869 4883 4905 4919 4941 4955 4977 4991 5013 5027 5049 5063 5085 5099 5121 5135 5157 5171 5193 5207 5229 5243 5265 5279 5301 5315"
      set values "Master Contact 2 0"
      set nassigned  [eval "GiD_AssignData condition $cond surfaces {$values} {$cm_surfaces}"]
      if { $nassigned <= 0 } {
	   WarnWinText "WARNING: condition can not be assigned for surfaces $cm_surfaces"
      }
}

proc MasterSlave_Layer_Assignment { } {

    set Smooth_geometry [GiD_AccessValue get gendata "Smooth_geometry"]
    if { $Smooth_geometry == 0 } {
	MasterSlave_for_All_Layers
    } else {
	MasterSlave_NextToInsulation
    }
}

proc MasterSlave_NextToInsulation { } {

      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
      if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   return ""
      }
      MasterSlave_GapNum 2
      MasterSlave_GapNum 3
}

proc MasterSlave_for_All_Layers { } {

      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
      if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   return ""
      }

      set nLayers [Get_nLayers ]
      for { set i 1 } { $i < $nLayers} {set i [expr $i+1]} {
	    MasterSlave_GapNum $i
      }
      return ""
}

proc Collapse_All_Geometry { } {

      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set nLayers [Get_nLayers ]

      set NumMacr [GiD_AccessValue get gendata "MacroelementCount"]
      set nSandwic [expr $NumMacr / double($nLayers)]
      set surface_list ""

  GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 0
  GiD_Process escape escape escape escape Utilities Variables ImportTolerance 2e-4

      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {

		 set material_name [lindex $valuesLayer [expr 3+4*($i-1)]]
#                 WarnWinText "material_name=$material_name"
	   if { $material_name != "" } {
		   if { $i != 3 } {
		        set surface_list "$surface_list [GiD_Info layers -entities surfaces $material_name]"
		}
	   }
      }
      set surface_list [lsort -integer -unique $surface_list]
      eval GiD_Process escape escape escape escape utilities Collapse surfaces selection $surface_list escape escape

# inslation
      set material_name [lindex $valuesLayer [expr 3+4*(3-1)]]
      set surface_list [GiD_Info layers -entities surfaces $material_name]
# WarnWinText "material_name=$material_name - surface_list=$surface_list"
      eval GiD_Process escape escape escape escape utilities Collapse surfaces selection $surface_list escape escape

  GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 1
}

proc Collapse_Geometry { } {

    set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
    if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   GiD_Process escape escape escape escape utilities Collapse Model Yes
	   return ""
    }

    set Smooth_geometry [GiD_AccessValue get gendata "Smooth_geometry"]
    if { $Smooth_geometry == 1 } {
	Collapse_All_Geometry
    } else {
        Collapse_Layer_Geometry
    }
    return ""
}

proc Collapse_Layer_Geometry { } {

      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set nLayers [Get_nLayers ]

      set NumMacr [GiD_AccessValue get gendata "MacroelementCount"]
      set nSandwic [expr $NumMacr / double($nLayers)]

  GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 0
  GiD_Process escape escape escape escape Utilities Variables ImportTolerance 1e-4

      set mezera_vyjma_posledni_layer " "
      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {

		 set material_name [lindex $valuesLayer [expr 3+4*($i-1)]]
#                 WarnWinText "material_name=$material_name"
	   if { $material_name != "" } {
		set b_surface_list [GiD_Info layers -entities surfaces $material_name]
		   eval GiD_Process escape escape escape escape utilities Collapse surfaces selection $b_surface_list escape escape
	   }
      }
  GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 1
}

proc CalculateCollapseSurfaceSelection { iSandwich numSurface oLayer onLayer } {
	set oSurfSel  [expr $nLayers*($-1) +3]
	return $oSurfSel
}
proc Advanced_Smooth_Interface_Mesh { } {

      # "// utilities Collapse mesh Yes"
      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
#      set o1adv_frm [string equal $adv_frm "Advanced_Other_Panel"]
#      set o2adv_frm [string equal $adv_frm "Advanced_Frame_Panel"]
#      if { $o1adv_frm == 1 || $o2adv_frm == 1 }
    if { $adv_frm != "Advanced_Frame_Panel" && $adv_frm != "Advanced_Other_Panel"} {
	   GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 0
	   GiD_Process escape escape escape escape Utilities Variables ImportTolerance 1e-4

	   GiD_Process escape escape escape escape utilities Collapse mesh Yes
	   # eval GiD_Process escape escape escape escape Mesh "Edit Mesh" Collapse mesh Yes

	   GiD_Process escape escape escape escape Utilities Variables AutoImportTolerance 1
      }
      return ""
}

proc GenerateMonitorCond { iLayer ICurrentMacroelementID prepinac_Int_Ext_surf cond_name } {

	set IPreviousMacrID [expr $ICurrentMacroelementID-1]
	if {$IPreviousMacrID < 0} {
		WarnWinText "WARNING: IPreviousMacrID=$IPreviousMacrID < 0 !!!"
	}

	set cond Monitor_for_Point
	if {$prepinac_Int_Ext_surf == 1} {
		set ID_Monitor_Jointu [expr $IPreviousMacrID*8+3]
		# set MonitorName "T_Exterior"
	} else {
		set ID_Monitor_Jointu [expr $IPreviousMacrID*8+4]
		# set MonitorName "T_Interior"
	}
	set MonitorName $cond_name
	set values "CURRENT_PSI_VALUES 0 0 0 0 1 0 0 $MonitorName"
	#           WarnWinText "WARNING: val=$values"
	set nassigned  [GiD_AssignData condition $cond points $values $ID_Monitor_Jointu]
	if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition $cond val=$values can not be assigned for points $ID_Monitor_Jointu to MELM $ICurrentMacroelementID"
	}
}

proc GenerateBoundaryCond { iLayer ICurrentMacroelementID IHorniMacr IDolniMacr ILevyMacr IPravyMacr IPredniStrana IZadniStrana DInternal_Temp DExternal_Temp } {

#   WarnWinText "$iLayer $ICurrentMacroelementID $IHorniMacr $IDolniMacr $ILevyMacr $IPravyMacr $IPredniStrana $IZadniStrana $DInternal_Temp $DExternal_Temp"

   set IPreviousMacrID [expr $ICurrentMacroelementID-1]
   if {$IPreviousMacrID < 0} {
	WarnWinText "WARNING: IPreviousMacrID=$IPreviousMacrID < 0 !!!"
   }

#  set NV [GiD_AccessValue set gendata "VolumeCount"  [GiD_Info Geometry NumVolumes]]
#  set NS [GiD_AccessValue set gendata "SurfaceCount" [GiD_Info Geometry NumSurfaces]]
#  set NL [GiD_AccessValue set gendata "LineCount"    [GiD_Info Geometry NumLines]]

#    WarnWinText $NV
#    WarnWinText $NS
#    WarnWinText $NL

   set defaultlayer "Layer0"
   set cond DirichletBoundary_for_Surface

#   WarnWinText "cond=Temperature1 $DInternal_Temp"
   if {$IPredniStrana==1} {
	   set ID_Predni_plocha [expr $IPreviousMacrID*6+5]
#           set values "0 0 1 $DInternal_Temp 0 200 $ID_Predni_plocha"
	   set values "0 0 1 $DInternal_Temp 0 200 0"
#           WarnWinText "WARNING: val=$values"
	   set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Predni_plocha]
	   if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition $cond val=$values can not be assigned for surfaces $ID_Predni_plocha to MELM $ICurrentMacroelementID"
	   }
   }
#   WarnWinText "cond=Temperature2 $DExternal_Temp"
   if {$IZadniStrana==1} {
	   set ID_Zadni_plocha [expr $IPreviousMacrID*6+3]
#           set values "0 0 1 $DExternal_Temp 0 200 $ID_Zadni_plocha"
	   set values "0 0 1 $DExternal_Temp 0 200 0"
	   set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Zadni_plocha]
	   if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition $cond val=$values can not be assigned for surfaces $ID_Zadni_plocha to MELM $ICurrentMacroelementID"
	   }
   }

   if {$iLayer==1} {
# pouze pro prvni Layer
	set cond Constraint_for_Line
	set ID_Horni_linie [expr $IPreviousMacrID*12+8]
	set ID_Dolni_linie [expr $IPreviousMacrID*12+4]

#        WarnWinText "cond=Constraint1 $IHorniMacr"
	if {$IHorniMacr==1} {
		set cond Constraint_for_Line
#               set values "GLOBAL 1 0 0 0 0 0 $ID_Horni_linie 2"
		set values "GLOBAL 1 0 0 0 0 0 2 0"
		# WarnWinText "$iLayer $ICurrentMacroelementID; cond=$cond lines $values $ID_Horni_linie"
		set nassigned  [GiD_AssignData condition $cond lines $values $ID_Horni_linie]
		if { $nassigned <= 0 } {
		        WarnWinText "WARNING: condition can not be assigned for line $ID_Horni_linie to MELM $ICurrentMacroelementID"
		}
#                WarnWinText "horni line $ID_Horni_linie to MELM $ICurrentMacroelementID, Previous=$IPreviousMacrID"
	}
#        WarnWinText "cond=Constraint2 $IDolniMacr"
	if {$IDolniMacr==1} {
#               set values "GLOBAL 1 0 0 0 0 0 $ID_Dolni_linie 2"
		set values "GLOBAL 1 0 0 0 0 0 2 0"
		set nassigned  [GiD_AssignData condition $cond lines $values $ID_Dolni_linie]
		if { $nassigned <= 0 } {
		        WarnWinText "WARNING: condition can not be assigned for line $ID_Dolni_linie to MELM $ICurrentMacroelementID"
		}
#                WarnWinText "dolni line $ID_Dolni_linie to MELM $ICurrentMacroelementID, Previous=$IPreviousMacrID"
	}
   }

   set cond Constraint_for_Surface
#   WarnWinText "cond=Constraint3 $IHorniMacr"
   if {$IHorniMacr==1} {
	  set ID_Horni_plocha [expr $IPreviousMacrID*6+6]
#         set values "GLOBAL 0 0 1 0 0 0 $ID_Horni_plocha 2"
	  set values "GLOBAL 0 0 1 0 0 0 2 0"
	  set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Horni_plocha]
	  if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition can not be assigned for surfaces $ID_Horni_plocha to MELM $ICurrentMacroelementID"
	  }
   }
#   WarnWinText "cond=Constraint4 $IDolniMacr"
   if {$IDolniMacr==1} {
	  set ID_Dolni_plocha [expr $IPreviousMacrID*6+1]
#         set values "GLOBAL 0 0 1 0 0 0 $ID_Dolni_plocha 2"
	  set values "GLOBAL 0 0 1 0 0 0 2 0"
	  set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Dolni_plocha]
	  if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition can not be assigned for surfaces $ID_Dolni_plocha to MELM $ICurrentMacroelementID"
	  }
   }
#   WarnWinText "cond=Constraint5 $ILevyMacr"
   if {$ILevyMacr==1} {
	  set ID_Leva_plocha [expr $IPreviousMacrID*6+2]
#         set values "GLOBAL 0 1 0 0 0 0 $ID_Leva_plocha 2"
	  set values "GLOBAL 0 1 0 0 0 0 2 0"
	  set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Leva_plocha]
	  if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition can not be assigned for surfaces $ID_Leva_plocha to MELM $ICurrentMacroelementID"
	  }
   }
#   WarnWinText "cond=Constraint6 $IPravyMacr"
   if {$IPravyMacr==1} {
	  set ID_Prava_plocha [expr $IPreviousMacrID*6+4]
#         set values "GLOBAL 0 1 0 0 0 0 $ID_Prava_plocha 2"
	  set values "GLOBAL 0 1 0 0 0 0 2 0"
	  set nassigned  [GiD_AssignData condition $cond surfaces $values $ID_Prava_plocha]
	  if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition can not be assigned for surfaces $ID_Prava_plocha to MELM $ICurrentMacroelementID"
	  }
   }
}

proc Assign_all_BoundaryConditions_for_all_Sandwices { } {
   global GIDDEFAULT

#  WarnWinText [GiD_Info variables CalcWithoutMesh]
   set OldCalcWithoutMesh [GiD_Info variables CalcWithoutMesh]
   GiD_Process escape escape escape escape utilities variables CalcWithoutMesh 1

#  WarnWinText [pwd]
   cd $GIDDEFAULT
#  WarnWinText $GIDDEFAULT

   GiD_Process escape escape escape escape Files WriteForBAS "Problemtypes/AtenaV4/include.src.bas/GenerateBC_Sandwich3D.bas" problemtypes/AtenaV4/jn_temp.txt \

   GiD_Process escape escape escape escape utilities variables CalcWithoutMesh OldCalcWithoutMesh
#  GiD_Process escape escape escape escape utilities variables CalcWithoutMesh 0

   GiD_Process escape escape escape escape
}

proc Delete_Sandwich3D_Geometry { } {

#   GiD_Process escape escape escape escape geometry delete AllTypes
#   GiD_Process escape Geometry Delete All layer:Layer0 escape escape
    GiD_Process escape escape escape Geometry Delete Volume layer:Layer0 escape escape
    GiD_Process escape escape escape Geometry Delete Surface layer:Layer0 escape escape
    GiD_Process escape escape escape Geometry Delete Line layer:Layer0 escape escape
    GiD_Process escape escape escape Geometry Delete Point layer:Layer0 escape escape
    GiD_Process escape escape escape Meshing CancelMesh Yes

    GiD_Process escape escape escape escape

   sw_SetInternalVariable "sw_GenerateMacroelem"      1
   sw_SetInternalVariable "sw_AssignMaterialToMacroelem" 1
   sw_SetInternalVariable "sw_Generate_Boundary_Cond" 1

   GiD_AccessValue set gendata MacroelementCount 0
   GiD_AccessValue set gendata ContactCount      0
#  GiD_AccessValue set gendata nIntervals        0
}

proc Delete_Sandwich3D_Load_History { ooutput } {
   set cIntervals [lindex [GiD_Info IntvData NUM] 1]
   # WarnWinText "Number of Interval is $cIntervals"

   if { $cIntervals > 1 } {
	GiD_AccessValue set gendata nIntervals $cIntervals
	for {set i $cIntervals} {$i > 1} {set i [expr $i-1]} {
		GiD_IntervalData delete $i
	}
	GiD_AccessValue set gendata nIntervals 1
	UnAssign_Condition "Elements_Activity_for_Volume"

	   #set cIntervals [lindex [GiD_Info IntvData NUM] 1]
	   #WarnWinText "Number of Interval is $cIntervals"

	   if { $ooutput > 0 } {
		   set text "Load History was deleted!"
		tk_messageBox -icon info -title [_ "Info:"] -type ok \
		              -message "$text"
#               WarnWinText "WARNING: Loading History was delete it!"
	   }
   }
   GiD_AccessValue set gendata sw_LoadHistory_Generate 0
}

proc Set_Sandwich_Layer_to_Layers { } {

#      set adv_frm [GiD_AccessValue get gendata "Predefined_Structure"]
#      if { $adv_frm != "Advanced_Frame_Panel"} {
#                return ""
#      }

      set valuesLayer [GiD_AccessValue get gendata "Layer"]
      set nLayers [Get_nLayers ]

      set NumMacr [GiD_AccessValue get gendata "MacroelementCount"]
      set nSandwic [expr $NumMacr / double($nLayers)]

      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {

		 set material_name [lindex $valuesLayer [expr 3+4*($i-1)]]
#                 WarnWinText "material_name$i =$material_name"
	   if { $material_name != "" } {
		   GiD_Process layer new $material_name escape
	   }
      }

      GiD_Process layer Touse Layer0 escape
      for {set i 1} {$i <= $nLayers} {set i [expr $i+1]} {

		set material_name [lindex $valuesLayer [expr 3+4*($i-1)]]

		for {set j $i} {$j <= $NumMacr} {set j [expr $j+$nLayers]} {
		      GiD_Process layer entities $material_name LowerEntities Volumes $j escape escape escape escape
		}
      }
}

proc sw_SetInternalVariable { sw_ oparam } {
#    WarnWinText "proc sw_SetInternalVariable"
#    WarnWinText $sw_
#    WarnWinText $oparam

    set nassigned  [GiD_AccessValue set gendata "$sw_" $oparam]
#    if { $nassigned <= 0 } {
#         WarnWinText "WARNING: Generate_Boundary_Cond set it to 0 failed!"
#    }
}

proc Assign_Elements_for_BC_Deleting { } {

	set type_predefined_structure [GiD_AccessValue get gendata "Predefined_Structure"]
	if {$type_predefined_structure != "Advanced_Frame_Panel"} {
		return ""
	}

	set valuesLayer [GiD_AccessValue get gendata "Layer"]
	set nLayers [Get_nLayers ]

	if { $nLayers < 3 } {
	       return ""
	}

	 set cond Elements_Activity_for_Volume
#        set list_free_vol "27 32 37 47 52 57 67 72 77 122 127 132 207 212 217 232 327 332 337 342 347 352 447 452 457 472 487 492 497 512 522 527 532 537 552 562 567 572 577 592 602 607 612 617 632 727 732 737 742 747 752"
	set list_free_vol [expr 5*$nLayers+2]
	set list_free_vol "$list_free_vol [expr 6*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 7*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 9*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 10*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 11*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 13*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 14*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 15*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 24*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 25*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 26*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 37*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 38*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 39*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 42*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 61*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 62*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 63*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 64*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 65*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 66*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 85*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 86*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 87*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 90*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 93*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 94*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 95*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 98*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 100*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 101*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 102*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 103*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 106*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 108*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 109*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 110*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 111*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 114*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 116*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 117*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 118*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 119*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 122*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 141*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 142*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 143*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 144*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 145*$nLayers+2]"
	set list_free_vol "$list_free_vol [expr 146*$nLayers+2]"
#        set list_free_vol "$list_free_vol [expr *$nLayers+2]"
#        WarnWinText "list_free_vol=$list_free_vol"

	set values "DELETE CC3DNonLinCementitious2 {E 32000 MU 0.2}"
	set nassigned  [GiD_AssignData condition $cond volumes $values $list_free_vol]
	if { $nassigned <= 0 } {
		WarnWinText "WARNING: condition $cond val=$values can not be assigned for volumes $list_free_vol"
	}
}

proc UnAssign_Condition { cnd } {

	set afp [GiD_AccessValue get gendata "Predefined_Structure"]
	if {$afp != "Advanced_Frame_Panel"} {
		return ""
	}

	eval GiD_Process escape escape escape escape data cond assign $cnd delete yes escape
#       WarnWinText "WARNING: $cnd delete "
#       GiD_Process escape escape escape escape data cond assign [DWGetGIDCondName $cnd] delete yes escape
}

proc Generate_Sandwich3D_Load_History { } {

   global GidPriv

   set last_time -1

   set predefined_structure [GiD_AccessValue get gendata "Predefined_Structure"]
   set array_values [GiD_AccessValue get gendata Radiation]
   set array_incr_values [GiD_AccessValue get gendata Increment_Radiation]
   set NumCells [lindex $array_values 1]
   set start_time 0.0
   set ci1 0
   set ci2 0
   set ci3 0
   set ci4 0
   set ei1 [GiD_AccessValue get gendata "Time1_To"]
   set ei2 [GiD_AccessValue get gendata "Time2_To"]
   set ei3 [GiD_AccessValue get gendata "Time3_To"]
   set ei4 [GiD_AccessValue get gendata "Time4_To"]
   set T_period [GiD_AccessValue get gendata "T_period"]

        	set n [GidConvertValueUnit $ei1]
	      set n [ParserNumberUnit $n ei1 unit]
	      
        	set n [GidConvertValueUnit $ei2]
	      set n [ParserNumberUnit $n ei2 unit]
	      
        	set n [GidConvertValueUnit $ei3]
	      set n [ParserNumberUnit $n ei3 unit]
	      
        	set n [GidConvertValueUnit $ei4]
	      set n [ParserNumberUnit $n ei4 unit]
	      
	        set n [GidConvertValueUnit $T_period]
	      set n [ParserNumberUnit $n T_period unit]


   set NumIncrVal [lindex $array_incr_values 1]
   set PreviousHistory [GiD_AccessValue get gendata nIntervals]
   if {$PreviousHistory>1} {
	GiD_IntervalData set 1
	Delete_Sandwich3D_Load_History 0
   }

   if {$NumIncrVal<6} {
	   set text "Please set Load History in setting and then try generation again!"
	   tk_messageBox -icon error -title [_ "Info:"] -type ok \
		         -message "$text"
	   return ""
   }

   for {set i 6} {$i <= $NumCells} {set i [expr $i+3]} {

#        WarnWinText "i=$i, NumCells=$NumCells, array_incr_values=$array_incr_values"
	set oiv [lindex $array_incr_values $i]
#        WarnWinText "op=$op"
	set incr_value [expr 1.0 *[format %lf $oiv]]
#        WarnWinText "incr_value=$incr_value"

	set incr_time [expr 1.0 *[format %lf [lindex $array_incr_values [expr $i-1]]]]
#        WarnWinText "incr_time=$incr_time"

	set end_time [expr 1.0 *[format %lf [lindex $array_values [expr $i-1]]]]
#        WarnWinText "end_time= $end_time"

#       set start_time [expr $end_time - $incr_time]
	set start_time [expr 1.0 *[format %lf [lindex $array_values [expr $i-1-3]]]]
#        WarnWinText "start_time= $start_time"

	set NumOfInternSteps [expr 1.0 * [lindex $array_incr_values [expr $i+1]]]
	set NumOfInternSteps [expr int($NumOfInternSteps)]
	
	if {$NumOfInternSteps == 0} {
		set NumOfInternSteps 1
	}

#       WarnWinText $NumOfInternSteps

	set i1 [expr $i/3.0]
#       GiD_Process escape escape escape escape Data Intervals NewInterval Ok Yes
	GiD_IntervalData create copyconditions
	GiD_IntervalData set $i1

#        if { $i == 6 && $predefined_structure == "Advanced_Frame_Panel" } {
#                set cnd "Elements_Activity_for_Volume"
#                GiD_Process escape escape escape escape data cond assign Elements_Activity_for_Volume delete yes escape
##                UnAssignCond  $cnd
##                GiD_Process escape escape escape escape data cond unassign $cnd yes escape
##              GiD_Process escape escape escape escape data cond assign $GidPriv($cnd) unassign escape
##              GiD_Process escape escape escape escape data cond assign [DWGetGIDCondName $cnd] delete yes escape
#        }
	set i1 [expr int($i1)]
	GiD_AccessValue set gendata nIntervals $i1

	set itt [expr $incr_time / double($NumOfInternSteps)]
	set units sec
	set ittunit [format %g%s $itt $units]
	set naccess [GiD_AccessValue set intvdata $i1 INCREMENT_TRANSIENT_TIME $ittunit]

	set units C
	set itti [format %g%s $incr_value $units]
#        WarnWinText $itti

	set naccess [GiD_AccessValue set intvdata $i1 Total_Temp_Incr $itti]
	set naccess [GiD_AccessValue set intvdata $i1 Total_Incr_Temp $itti]

#        WarnWinText $NumOfInternSteps $i1

	if {$NumOfInternSteps>=1} {
		set naccess [GiD_AccessValue set intvdata $i1 Generate_Multiple_Steps  1]
	} else {
		set naccess [GiD_AccessValue set intvdata $i1 Generate_Multiple_Steps  0]
	}
	set naccess [GiD_AccessValue set intvdata $i1 Number_of_LOAD_STEPs $NumOfInternSteps]
	set naccess [GiD_AccessValue set intvdata $i1 Number_of_TRANSPORT_LOAD_STEPs $NumOfInternSteps]

	set storeresults [GiD_AccessValue get gendata "STORE_RESULTS"]
	if { $storeresults == "WITHOUT_SAVING" } {
		set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "WITHOUT_SAVING" ]
	} elseif { $storeresults == "SAVE_ALL" } {
		set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "SAVE_ALL" ]
	} elseif { $storeresults == "SAVE_EACH_HOUR" } {
		set ttime [expr int($end_time/3600.0)]
		# set end_ttime [expr $end_time/3600.0 ]

		if { $ttime == [expr $last_time+1] || $i == $NumCells } {
		        set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "SAVE_ALL" ]
		} else {
		        set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "WITHOUT_SAVING" ]
		}
		set last_time $ttime
	} elseif { $storeresults == "SAVE_ENDS_OF_INTERVALS" } {
		set fend_time $end_time
		set ef 0
		for { set oi 0 } { $ef == 0 } { set oi [expr $oi + 1] } {
		        if { $end_time > $T_period && $fend_time > $T_period} {
		                set fend_time [expr $fend_time-$T_period]
		                # WarnWinText "$oi, $fend_time, $end_time"
		        } else {
		                set ef 1
		        }
		}
		if { $fend_time < $ei1 } {
		        set ci1 [expr $ci1 + 1]
		        set ef 1
		        set ci2 0
		        set ci3 0
		        set ci4 0
		} elseif { $fend_time < $ei2 } {
		        set ci2 [expr $ci2 + 1]
		        set ef 1
		        set ci1 0
		        set ci3 0
		        set ci4 0
		} elseif { $fend_time < $ei3 } {
		        set ci3 [expr $ci3 + 1]
		        set ef 1
		        set ci1 0
		        set ci2 0
		        set ci4 0
		} elseif { $fend_time < $ei4 } {
		        set ci4 [expr $ci4 + 1]
		        set ef 1
		        set ci1 0
		        set ci2 0
		        set ci3 0
		}

		# WarnWinText "$ci1, $ci2, $ci3, $ci4"

		# WarnWinText "$ci1, $ci2, $ci3, $ci4, $i, $NumCells"

		if { $ci1 == 1 || $ci2 == 1 || $ci3 == 1 || $ci4 == 1 || $i == $NumCells } {
		               set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "SAVE_ALL" ]
		} else {
		        set naccess [GiD_AccessValue set intvdata $i1 Store_Data_for_this_Interval_Steps "WITHOUT_SAVING" ]
		}
	}
	set text "Multilinear #"
	lappend text $i1
#       WarnWinText $text

	set naccess [GiD_AccessValue set intvdata $i1 LOAD_NAME $text]
	set naccess [GiD_AccessValue set intvdata $i1 TEMP_LOAD_STEP_Multiplier [expr $incr_value/double($NumOfInternSteps)]]

	set units sec
	set naccess [GiD_AccessValue set intvdata $i1 INTERVAL_STARTING_TIME  [format %g%s $start_time $unit]]
	# set oittxjn [GiD_AccessValue get intvdata $i1 INCREMENT_TRANSIENT_TIME]
	#        set n [GidConvertValueUnit $oittxjn]
	#      set oittxjn [ParserNumberUnit $n oittxjn unit]
	set naccess [GiD_AccessValue set intvdata $i1 INTERVAL_END_TIME [format %g%s [expr $itt+$start_time] $unit]]

	# WarnWinText "$itt $start_time $oittxjn [expr $oittxjn+$start_time]"

#       set start_time [expr $start_time $itt]
   }
   GiD_AccessValue set gendata nIntervals [GiD_Info intvdata NUM]

#  zvlaste je treba nastavit Interval C.1
#  WarnWinText "array_incr_values=$array_incr_values"

   set incr_time        [expr 1.0 * [format %lf [lindex $array_incr_values 2]]]
   set incr_value       [expr 1.0 * [format %lf [lindex $array_incr_values 3]]]
   set p_time           [format %lf [lindex $array_values 2]]
   set start_time       [expr 1.0 * ($p_time - $incr_time)]
#  set tempVal          [expr 1.0 * [format %lf [lindex $array_values 3]]]
#  set NumOfInternSteps [expr 1.0 * [format %lf [lindex $array_values 4]]]
   set NumOfInternSteps [expr 1.0 * [lindex $array_incr_values 4]]
   if {$NumOfInternSteps == 0.0} {
	set NumOfInternSteps 1
   }

   set units sec
   set itt [expr $incr_time / double($NumOfInternSteps)]
   set naccess [GiD_AccessValue set intvdata 1 INCREMENT_TRANSIENT_TIME [format %g%s $itt $unit]]
   set naccess [GiD_AccessValue set intvdata 1 Generate_Multiple_Steps  1]
   set naccess [GiD_AccessValue set intvdata 1 Number_of_LOAD_STEPs $NumOfInternSteps]

   set units C
   set itti [format %g%s $incr_value $units]
#   WarnWinText $itti

   set naccess [GiD_AccessValue set intvdata 1 Total_Temp_Incr $itti]
   set naccess [GiD_AccessValue set intvdata 1 Total_Incr_Temp $itti]

   set naccess [GiD_AccessValue set intvdata 1 Number_of_TRANSPORT_LOAD_STEPs $NumOfInternSteps]
   set naccess [GiD_AccessValue set intvdata 1 Store_Data_for_this_Interval_Steps "SAVE_ALL"]

   set naccess [GiD_AccessValue set intvdata 1 LOAD_NAME "Multilinear Radiation #1"]
   set naccess [GiD_AccessValue set intvdata 1 TEMP_LOAD_STEP_Multiplier [expr $incr_value/$NumOfInternSteps]]

   set naccess [GiD_AccessValue set intvdata 1 INTERVAL_STARTING_TIME  [format %g%s $start_time $unit]]
   # set oittxjn [GiD_AccessValue get intvdata 1 INCREMENT_TRANSIENT_TIME]
   #	        set n [GidConvertValueUnit $oittxjn]
   #	      set oittxjn [ParserNumberUnit $n oittxjn unit]
   set naccess [GiD_AccessValue set intvdata 1 INTERVAL_END_TIME [format %g%s [expr $itt+$start_time] $unit]]

   #	WarnWinText "$itt $start_time $oittxjn [expr $oittxjn+$start_time]"

   set sw_lh [GiD_AccessValue get gendata sw_LoadHistory_Generate]

   GiD_AccessValue set gendata sw_LoadHistory_Generate 0
   GiD_IntervalData set 1
   Assign_Elements_for_BC_Deleting

   if { $p_time == 0.0 } {
	   set text "The first time step can't finished at 0 sec. Please repair 1.line of Table of Load History setting"
	   tk_messageBox -icon error -title [_ "Error:"] -type ok \
		         -message "$text"
	   Delete_Sandwich3D_Load_History 0
	   return ""
   }

   set text  "0"
   if {$sw_lh==0} {
	   set text "Load History was deleted and re-generated!"
   } else {
	   set text "Load History was generated!"
   }

   tk_messageBox -icon info -title [_ "Info:"] -type ok \
		 -message "$text"

   GiD_Process escape escape escape escape Meshing Generate
   # set cmd "escape escape escape escape Meshing Generate"
   # append cmd " Ok"
   # eval GiD_Process $cmd \
}

proc Assign_all_Materials_for_all_Sandwices { } {
   global GIDDEFAULT

#  WarnWinText [GiD_Info variables CalcWithoutMesh]
   set OldCalcWithoutMesh [GiD_Info variables CalcWithoutMesh]
   GiD_Process escape escape escape escape utilities variables CalcWithoutMesh 1

#  WarnWinText [pwd]
   cd $GIDDEFAULT
#  WarnWinText $GIDDEFAULT

   GiD_Process escape escape escape escape Files WriteForBAS "Problemtypes/AtenaV4/include.src.bas/GenerateMaterial_Sandwich3D.bas" problemtypes/AtenaV4/jn_temp.txt \

   GiD_Process escape escape escape escape utilities variables CalcWithoutMesh OldCalcWithoutMesh
#  GiD_Process escape escape escape escape utilities variables CalcWithoutMesh 0

   GiD_Process escape escape escape escape
}

proc AtenaTemperatureCalculate {} {

    # GiD_ModifyData gendata Calculation_Type Calculation_Analysis SandwichTemperature3D
    # Advanced_Smooth_Interface_Mesh

    # GiD_Process escape escape escape escape utilities Collapse mesh yes
    
    GiD_Process escape escape escape escape Utilities Calculate
}

proc AtenaStaticCalculate {} {
#    GiD_ModifyData gendata Calculation_Type Calculation_Analysis "SandwichStatic3D"

     # GiD_Process escape escape escape escape Meshing Generate Yes escape escape

#    GiD_Process escape escape escape escape Utilities Calculate

    global GIDDEFAULT
#    WarnWinText $GIDDEFAULT

    set aa [GiD_Info Project]
    set ProblemType [lindex $aa 0]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
	  set ProjectName [file root $ProjectName]
    }

#    WarnWinText "aa, ProblemType, ProjectName1"
#    WarnWinText $aa
#    WarnWinText $ProblemType
#    WarnWinText $ProjectName

    set ProjectName [file root $ProjectName]
    set Sandwic_taskdir $ProjectName.gid
    set basename [file tail $ProjectName]

#    WarnWinText "ProjectName2, basename"
#    WarnWinText $ProjectName
#    WarnWinText $basename

    set ProblemDirectory $ProblemType.gid
#    WarnWinText "pd1=$ProblemDirectory "

    if { ![file isdirectory $ProblemDirectory] } {
	set ProblemDirectory [file join $GIDDEFAULT problemtypes $ProblemType.gid]
    }
#    WarnWinText "pd2=$ProblemDirectory "

    if { ![file isdirectory $ProblemDirectory] } {
	set ProblemDirectory [file join $GIDDEFAULT $ProblemType.gid]
    }
#    WarnWinText "pd3=$ProblemDirectory "

    if { [file pathtype $ProblemDirectory] == "relative" } {
	set ProblemDirectory [file join [pwd] $ProblemType.gid]
    }
#    WarnWinText "pd4=$ProblemDirectory "

    if { ![file isdirectory $ProblemDirectory] } {
	return ""
    }
    if { $ProjectName == "UNNAMED" } {
	return ""
    }

    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
#    WarnWinText "d5=$directory"

    set args ""
    set list ""
    catch {set list [SelectGIDBatFile $directory $basename]}
    if {$list != ""} {
	set file [file native  [file join $ProblemDirectory [lindex $list 0]]]
	# if " is added, an argument list will be treated as one argument
	set args [lrange $list 1 end]
#        WarnWinText "file6=$file"
    }
#    WarnWinText "args6=$args"

    if {$list == ""} {
	set file ""
	    set tmpfile [file native [file join $ProblemDirectory \
		        [file tail $ProblemType]_stat.win.bat]]
	    if { [file exists $tmpfile] } {
		set file $tmpfile
	    }
	if { $file == "" } {
	    set file [file native  [file join $ProblemDirectory [file tail $ProblemType].bat]]
	}
	set args ""
    }
#    WarnWinText "tmpfile7=$args"
#    WarnWinText "file7=$file"

    set outfilenames [PWFIndOutputFilename OutputFile $file $basename \
	   $directory $ProblemDirectory]
#     WarnWinText "outfilenames8 =$outfilenames "

#    WarnWinText $directory
#    WarnWinText "tmpfile="
#    WarnWinText $tmpfile
#    WarnWinText "file="
#    WarnWinText $file

#    WarnWinText "pwd9= [pwd]"
    cd $directory
#    WarnWinText "directory9= $directory"

#    append basename ".inp"
#    set TasknamePath $directory
#     append TasknamePath "\\" $basename
#     WarnWinText "TasknamePath10= $TasknamePath"
#    GiD_Process escape escape escape escape Files WriteForBAS $TasknamePath Save

    set DefaultFileNameInCalcFile \
	    [GiD_Info variables DefaultFileNameInCalcFile]
    if { $DefaultFileNAmeInCalcFile == 0 } {
	GiD_Process escape escape escape escape utilities variables \
		DefaultFileNAmeInCalcFile 1 escape
    }

#    WarnWinText "pwd10= [pwd]"
#    WarnWinText "directory=$directory"
#    WarnWinText "tmpfile=$tmpfile"
#    WarnWinText "file=$file"
#    WarnWinText "basename=$basename"
#    WarnWinText "ProblemDirectory=$ProblemDirectory"

#    GiD_Process escape escape escape escape files WriteCalcFile
    GiD_Process escape escape escape escape Files WriteForBAS "$ProblemDirectory/../Execute/Static3DExecute.bas" $basename.dat \

#   append AtenaStaticBatParams " " $basename " " $directory " " $ProblemDirectory
#   append AtenaStaticBatParams $basename ".inp " $basename ".out " $basename ".msg " $basename ".err"

#      set  inputfile $basename
#    append inputfile ".inp"
#      set  outputfile $basename
#    append outputfile ".out"
#      set  messagefile $basename
#    append messagefile ".msg"
#      set  errorfile $basename
#    append errorfile ".err"

    set AtenaStaticBat $GIDDEFAULT
    append AtenaStaticBat "/"
    append AtenaStaticBat "command.exe"
#    append AtenaStaticBat $file
#    WarnWinText $AtenaStaticBat
    exec $AtenaStaticBat $file $basename $directory $ProblemDirectory "STATIC" &
}
