
  # funkce na vypis funkce pro akcelerogram (dynamic))
proc DejFunkciGround { x int} {
#tk_messageBox -message "x = $x , int = $int" -icon warning -type ok
set soubor [GiD_AccessValue get intvdata $int "Import_function_from_file"] 
#tk_messageBox -message "$soubor" -icon warning -type ok

       set re {(?x)
      	\s+ ([[:graph:]]+)      # first number
      	\s+ ([[:graph:]]+)      # second number
       }
 
      set vypisX ""
      set vypisY ""        
       
     #set soubor "c:/text.txt"  
     set fp [open $soubor r]
     set data [read $fp]
     close $fp
     
     #  Process data file
     set data [split $data "\n"]
     foreach line $data {
     
      set line " $line "
      set line [string map { \; " " } $line]
      set line [string map { \, \. } $line]
      set b [regexp $re $line match matchX matchY]

      if {$b==1} {
      set vypisX "$vypisX $matchX"
      set vypisY "$vypisY $matchY"
      #tk_messageBox -message "x=$matchX y=$matchY polozka b= $b" -icon warning -type ok
      }
          
     }
    #tk_messageBox -message "vypisX=$vypisX" -icon warning -type ok
    #tk_messageBox -message "vypisY=$vypisY" -icon warning -type ok 
    
if {$x==0} { return "$vypisX" }
if {$x==1} { return "$vypisY" }

return ""
}


proc JN_InitGIDPostProcess {} {
    global taskdir
    global problem_dir
#     WarnWinText $taskdir
     cd $taskdir
#     WarnWinText [pwd]
     set A3Post $problem_dir
     append A3Post "/GiD3DPost.bat"
#     WarnWinText $A3Post
     exec $A3Post >post.txt >& NUL:
#     WarnWinText [pwd]
    set on [GiD_AccessValue get gendata Calculation_Analysis]
    
    if {[string equal $on "Static3D"] || [string equal $on "Static2D"]} {
     cd "AtenaCalculation"   
    }
    if {[string equal $on "Dynamic3D"] || [string equal $on "Dynamic2D"]} {
     cd "AtenaDynamicCalculation"  
    }
    if {[string equal $on "Creep3D"] || [string equal $on "Creep2D"]} {
     cd "AtenaCreepCalculation"  
    }
    if {[string equal $on "Temperature3D"] || [string equal $on "Temperature2D"]} {
     cd "AtenaTransportCalculation"   
    } 
    
    
    

     GiD_Process escape escape escape escape files read "AtenaResults.flavia.res"
#     WarnWinText "after ... GiD_Process escape escape escape escape files read AtenaResults.flavia.res"
     return ""
}

proc AtenaCalculate {} {
    WarnWin [join [list "For calculation use Calculate Menu and item Calculate or ATENA and item Atena Analysis!"]]
#     exec "c:/Program Files/CervenkaConsulting/ATENA v2/AtenaWin.exe"
#     {-np- AtenaCalculate }
}

#proc userHelpWindow {} {
#    exec NOTEPAD.EXE
#}

proc EndMyBitmaps {} {
    global ProgramName ProblemTypePriv

    ReleaseToolbar "$ProgramName prebar"
#    ReleaseToolbar "$ProgramName postbar"
    rename MyPreBitmaps ""
#    rename MyPostBitmaps ""
    catch { destroy $ProblemTypePriv(pretoolbarwin) }
#    catch { destroy $ProblemTypePriv(posttoolbarwin) } 
}

proc EndGIDProject {} {
    EndMyBitmaps 
    global GidPriv
    set GidPriv(ProgName) GiD
    ChangeWindowTitle ""
}


proc BeforeTransformProblemType { file oldproblemtype newproblemtype } {
#WarnWinText "old: $oldproblemtype"
#WarnWinText "new: $newproblemtype"
 set stornuj 0
 
 if { $oldproblemtype =="AtenaV4/Static" && $newproblemtype=="AtenaV4/Transport" || $oldproblemtype =="AtenaV4/Transport" && $newproblemtype=="AtenaV4/Static"} {
 set stornuj 1
 }
 if { $oldproblemtype =="AtenaV4/Dynamic" && $newproblemtype=="AtenaV4/Transport" || $oldproblemtype =="AtenaV4/Transport" && $newproblemtype=="AtenaV4/Dynamic"} {
 set stornuj 1
 }
 if { $oldproblemtype =="AtenaV4/Creep" && $newproblemtype=="AtenaV4/Transport" || $oldproblemtype =="AtenaV4/Transport" && $newproblemtype=="AtenaV4/Creep"} {
 set stornuj 1
 }
 
 if { $stornuj =="2"} {
 set warninfo "Transform from $oldproblemtype to $newproblemtype isn't allowed. Please use Update and define and assign the materials and conditions."
 WarnWinText "$warninfo"
  tk_messageBox -title "Warning: Unsupported transformation" -message "$warninfo" -icon warning -type ok
   return "-cancel-"
 } 
  return ""
 }
 
 proc AfterTransformProblemType { file oldproblemtype newproblemtype } {
 source "Problemtypes\\AtenaV4\\include.src.bas\\Ver_number.tcl"
  GiD_Process MEscape Data ProblemData "-SingleField-" Script_version $VersionNumberOnly
  GiD_Process MEscape Files Save
  tk_messageBox -message "Project transformed to ATENA-GiD scripts version $VersionNumberOnly" -type ok
   }

proc AfterOpenFile { filename format error } {
source "Problemtypes\\AtenaV4\\include.src.bas\\Ver_number.tcl" 
set answer [GiD_Info gendata]
# WarnWinText "$answer"
if [ string match -nocase "*Script_Version*" $answer ] {
# WarnWinText "ano retezec obsahuje Script_Version"
 set Exampleversion [GiD_AccessValue get gendata "Script_Version"]
# tk_messageBox -message "$Exampleversion  < $VersionNumberOnly" -type ok
# WarnWinText "$Exampleversion"
} else {
# WarnWinText "ne retezec neobsahuje Script_Version"
  set Exampleversion 0
}
 # if the example is too old
    if { $Exampleversion < $VersionNumberOnly} {
      set answer [tk_messageBox -title "ATENA-GiD" -message "Your project was created in ATENA-GiD scripts ($Exampleversion), but you are now using scripts ($VersionNumberOnly). \n\nDo you want to transform the project to the installed scripts?" -type yesno -icon question]
      switch -- $answer {
                   yes { DoTransform 
                   # WarnWinText "transformuji"
                   }
                   no {tk_messageBox -title "ATENA-GiD Warning" -message "Working on project which isn't transformed to the installed ATENA-GiD version is on your own risk!" -type ok -icon warning
                   # WarnWinText "NE transformuji"
                   }
                   
                   }
    }
 # if the example is too new
     if { $Exampleversion > $VersionNumberOnly} {
      set answer [tk_messageBox -title "ATENA-GiD" -message "Your ATENA-GiD scripts ($VersionNumberOnly) are older then scripts used to create this project ($Exampleversion). \nUsing newer project in older ATENA-GiD is on your own risk!\nPlease check our website for \"ATENA-GiD Interface\" updates. \n\nOpen http://www.cervenka.cz/downloads ?" -type yesno -icon question]
      switch -- $answer {
                   yes {VisitWeb http://www.cervenka.cz/downloads
                   # WarnWinText "ano vase skripty jsou starsi nez prikladove"
                   }
                   no {
                   # WarnWinText "NE vase skripty jsou starsi nez prikladove"
                   }
                   }
    }
  ZapisAktualniScriptPriSpusteni
}

proc Kontrolanovinek {oldproblemtype newproblemtype} {
#tk_messageBox -title "ATENA-GiD news" -message "$oldproblemtype $newproblemtype" -type ok -icon info

# 2187
    set version 2187
    if { $oldproblemtype < $version && $newproblemtype > $version } {
    set answer [tk_messageBox -title "ATENA-GiD news" -message "This is information about news in this version of ATENA-GiD\n\nThe SHELL and BEAM material definitions have changed in ATENA-GiD version 2187. We are sorry they can not be updated automatically, please re-define and re-assign them." -type ok -icon info]
    }
# 2187
    set version 2198
    if { $oldproblemtype < $version && $newproblemtype > $version } {
    set answer [tk_messageBox -title "ATENA-GiD news" -message "This is information about news in this version of ATENA-GiD\n\nIn the previous versions, the temperature values in the temp.dep. functions had to be given relative to the reference temperature, which means the user had to re-define all the functions to adjust to another reference/initial temperature. Since version 2198, the functions are defined in absolute temperatures and the adjustment due to the initial temperature is done automatically when writing the input file. You can set the init. temp. in this dialog to 0 to have the same behavior as in the previous version." -type ok -icon info]
    }
# 2860
    set version 2843
    if { $oldproblemtype < $version && $newproblemtype > $version } {
    set answer [tk_messageBox -title "ATENA-GiD news" -message "This is information about news in this version of ATENA-GiD\n\nNew material parameters FC_REDUCTION and AGG_SIZE have been added in version 2843. To achieve the same results as in the previous versions, you have to turn off Active_Aggregate_Interlock and set FC_REDUCTION = 1. Not for transport problem." -type ok -icon info]
    }
# 6160
    set version 6159
    if { $oldproblemtype < $version && $newproblemtype > $version } {
    set answer [tk_messageBox -title "ATENA-GiD news" -message "In models with construction process is necessary to replace conditions for NEW MATERIAL." -type ok -icon info]
    set answer [tk_messageBox -title "ATENA-GiD news" -message "Condition \"Spring for Line\" is not supported any more. Please assign Spring Material to the line instead." -type ok -icon info]
    }
    
    
    
return ""
}
